// Generated by LiveScript 1.3.1
(function(){
  var delay, Promise, timeLimitedPromise, toString$ = {}.toString;
  QUnit.module('core-js');
  delay = core.delay, Promise = core.Promise;
  timeLimitedPromise = function(time, fn){
    return Promise.race([
      new Promise(fn), new Promise(function(res, rej){
        return setTimeout(rej, time);
      })
    ]);
  };
  test('delay', function(it){
    it.expect(3);
    ok(toString$.call(delay).slice(8, -1) === 'Function', 'is function');
    ok(delay(42) instanceof Promise, 'returns promises');
    timeLimitedPromise(1e3, function(res){
      delay(10).then(function(it){
        res(it);
      });
    }).then(function(it){
      return ok(it === true, 'resolves as `true`');
    })['catch'](function(){
      return ok(false, 'rejected');
    }).then(it.async());
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, Dict, Set, Symbol, ref$, keys, create, assign, make, from, values, toString$ = {}.toString;
  QUnit.module('core-js');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  Dict = core.Dict, Set = core.Set, Symbol = core.Symbol;
  ref$ = core.Object, keys = ref$.keys, create = ref$.create, assign = ref$.assign, make = ref$.make;
  ref$ = core.Array, from = ref$.from, values = ref$.values;
  test('Dict', function(){
    var dict1, dict2, dict3, done, iter;
    ok(isFunction(Dict), 'Is function');
    dict1 = Dict();
    ok(!(dict1 instanceof Object));
    deepEqual(keys(dict1), []);
    dict2 = Dict({
      q: 1,
      w: 2
    });
    ok(!(dict2 instanceof Object));
    deepEqual(keys(dict2), ['q', 'w']);
    ok(dict2.q === 1);
    ok(dict2.w === 2);
    dict3 = Dict(new Set([1, 2]).entries());
    ok(!(dict3 instanceof Object));
    deepEqual(keys(dict3), ['1', '2']);
    ok(dict3[1] === 1);
    ok(dict3[2] === 2);
    done = false;
    iter = values([null, 1, 2]);
    iter['return'] = function(){
      return done = true;
    };
    try {
      new Dict(iter);
    } catch (e$) {}
    ok(done, '.return #throw');
  });
  test('Dict.every', function(){
    var every, obj, ctx;
    every = Dict.every;
    ok(isFunction(every), 'Is function');
    every(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      return ok(this === ctx);
    }, ctx = {});
    ok(every({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    ok(!every({
      q: 1,
      w: '2',
      e: 3
    }, function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
  });
  test('Dict.filter', function(){
    var filter, obj, ctx;
    filter = Dict.filter;
    ok(isFunction(filter), 'Is function');
    filter(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      return ok(this === ctx);
    }, ctx = {});
    deepEqual(filter({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return it % 2;
    }), Dict({
      q: 1,
      e: 3
    }));
  });
  test('Dict.find', function(){
    var find, obj, ctx;
    find = Dict.find;
    ok(isFunction(find), 'Is function');
    find(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      return ok(this === ctx);
    }, ctx = {});
    ok(find({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return !(it % 2);
    }) === 2);
  });
  test('Dict.findKey', function(){
    var findKey, obj, ctx;
    findKey = Dict.findKey;
    ok(isFunction(findKey), 'Is function');
    findKey(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      return ok(this === ctx);
    }, ctx = {});
    ok(findKey({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return it === 2;
    }) === 'w');
  });
  test('Dict.forEach', function(){
    var forEach, obj, ctx, rez;
    forEach = Dict.forEach;
    ok(isFunction(forEach), 'Is function');
    forEach(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      ok(this === ctx);
    }, ctx = {});
    rez = {};
    forEach({
      q: 1,
      w: 2
    }, function(){
      rez[arguments[1]] = arguments[0] + this;
    }, '_');
    deepEqual(rez, {
      q: '1_',
      w: '2_'
    });
    rez = true;
    forEach(obj = {
      q: 1,
      w: 2
    }, function(){
      var rez;
      rez && (rez = obj === arguments[2]);
    });
    ok(rez);
    rez = {};
    forEach(make({
      e: 3
    }, {
      q: 1,
      w: 2
    }), function(){
      rez[arguments[1]] = arguments[0];
    });
    ok(!('e' in rez));
    rez = {};
    forEach([1, 2], function(){
      rez[arguments[1]] = arguments[0];
    });
    ok(!('length' in rez));
    rez = {};
    forEach('123', function(){
      rez[arguments[1]] = arguments[0];
    });
    ok('2' in rez);
  });
  test('Dict.keyOf', function(){
    var keyOf;
    keyOf = Dict.keyOf;
    ok(isFunction(keyOf), 'Is function');
    ok(keyOf({
      q: 1,
      w: 2,
      e: 3
    }, 2) === 'w');
    ok(keyOf({
      q: 1,
      w: 2,
      e: 3
    }, 4) === void 8);
    ok(keyOf({
      q: 1,
      w: 2,
      e: NaN
    }, NaN) === void 8);
  });
  test('Dict.map', function(){
    var map, obj, ctx;
    map = Dict.map;
    ok(isFunction(map), 'Is function');
    map(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      return ok(this === ctx);
    }, ctx = {});
    deepEqual(map({
      q: 1,
      w: 2,
      e: 3
    }, (function(it){
      return Math.pow(it, 2);
    })), Dict({
      q: 1,
      w: 4,
      e: 9
    }));
  });
  test('Dict.mapPairs', function(){
    var mapPairs, obj, ctx;
    mapPairs = Dict.mapPairs;
    ok(isFunction(mapPairs), 'Is function');
    mapPairs(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      return ok(this === ctx);
    }, ctx = {});
    deepEqual(mapPairs({
      q: 1,
      w: 2,
      e: 3
    }, function(v, k){
      return v !== 2 && [k + k, v * v];
    }), Dict({
      qq: 1,
      ee: 9
    }));
  });
  test('Dict.reduce', function(){
    var reduce, obj, foo, memo;
    reduce = Dict.reduce;
    ok(isFunction(reduce), 'Is function');
    reduce(obj = {
      a: 1
    }, function(memo, val, key, that){
      ok(memo === foo);
      ok(val === 1);
      ok(key === 'a');
      return ok(that === obj);
    }, foo = {});
    reduce({
      a: 1,
      b: 2
    }, function(memo, val, key){
      ok(memo === 1);
      ok(val === 2);
      return ok(key === 'b');
    });
    reduce({
      q: 1,
      w: 2,
      e: 3
    }, function(that, it){
      that[it] = it;
      return that;
    }, memo = {});
    deepEqual(memo, {
      1: 1,
      2: 2,
      3: 3
    });
  });
  test('Dict.some', function(){
    var some, obj, ctx;
    some = Dict.some;
    ok(isFunction(some), 'Is function');
    some(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      return ok(this === ctx);
    }, ctx = {});
    ok(!some({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    ok(some({
      q: 1,
      w: '2',
      e: 3
    }, function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
  });
  test('Dict.includes', function(){
    var includes, dict, o;
    includes = Dict.includes;
    ok(isFunction(includes), 'Is function');
    dict = {
      q: 1,
      w: NaN,
      e: -0,
      r: o = {}
    };
    ok(includes(dict, 1));
    ok(includes(dict, -0));
    ok(includes(dict, 0));
    ok(includes(dict, NaN));
    ok(includes(dict, o));
    ok(!includes(dict, 4));
    ok(!includes(dict, -0.5));
    ok(!includes(dict, {}));
  });
  test('Dict.has', function(){
    var has;
    has = Dict.has;
    ok(isFunction(has), 'Is function');
    ok(has({
      q: 1
    }, 'q'));
    ok(!has({
      q: 1
    }, 'w'));
    ok(has([1], 0));
    ok(!has([], 0));
    ok(!has(clone$({
      q: 1
    }), 'q'));
    ok(!has({}, 'toString'));
  });
  test('Dict.get', function(){
    var get;
    get = Dict.get;
    ok(isFunction(get), 'Is function');
    ok(get({
      q: 1
    }, 'q') === 1);
    ok(get({
      q: 1
    }, 'w') === void 8);
    ok(get([1], 0) === 1);
    ok(get([], 0) === void 8);
    ok(get(clone$({
      q: 1
    }), 'q') === void 8);
    ok(get({}, 'toString') === void 8);
  });
  test('Dict.values', function(){
    var values, iter;
    values = Dict.values;
    ok(isFunction(values), 'Is function');
    iter = values({});
    ok(iter[Symbol != null ? Symbol.toStringTag : void 8] === 'Dict Iterator');
    ok('next' in iter);
    deepEqual(from(values({
      q: 1,
      w: 2,
      e: 3
    })), [1, 2, 3]);
    deepEqual(from(values(new String('qwe'))), ['q', 'w', 'e']);
    deepEqual(from(values(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    }))), [4, 5, 6]);
  });
  test('Dict.keys', function(){
    var keys, iter;
    keys = Dict.keys;
    ok(isFunction(keys), 'Is function');
    iter = keys({});
    ok(iter[Symbol != null ? Symbol.toStringTag : void 8] === 'Dict Iterator');
    ok('next' in iter);
    deepEqual(from(keys({
      q: 1,
      w: 2,
      e: 3
    })), ['q', 'w', 'e']);
    deepEqual(from(keys(new String('qwe'))), ['0', '1', '2']);
    deepEqual(from(keys(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    }))), ['a', 's', 'd']);
  });
  test('Dict.entries', function(){
    var entries, iter;
    entries = Dict.entries;
    ok(isFunction(entries), 'Is function');
    iter = entries({});
    ok(iter[Symbol != null ? Symbol.toStringTag : void 8] === 'Dict Iterator');
    ok('next' in iter);
    deepEqual(from(entries({
      q: 1,
      w: 2,
      e: 3
    })), [['q', 1], ['w', 2], ['e', 3]]);
    deepEqual(from(entries(new String('qwe'))), [['0', 'q'], ['1', 'w'], ['2', 'e']]);
    deepEqual(from(entries(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    }))), [['a', 4], ['s', 5], ['d', 6]]);
  });
  function clone$(it){
    function fun(){} fun.prototype = it;
    return new fun;
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, ref$, map, every, reduce, toString$ = {}.toString;
  QUnit.module('core-js');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  ref$ = core.Array, map = ref$.map, every = ref$.every, reduce = ref$.reduce;
  test('Function#part', function(){
    var part, $, obj, fn, p;
    part = core.Function.part;
    $ = core._;
    ok(isFunction(part), 'Is function');
    ok(part(function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }, 'qwe')());
    obj = {
      a: 42
    };
    obj.fn = part(function(it){
      return this.a + it;
    }, 21);
    ok(obj.fn() === 63);
    fn = function(){
      return map(arguments, String).join(' ');
    };
    p = part(fn, $, 'Саша', $, 'шоссе', $, 'сосала');
    ok(isFunction(p), '.part with placeholders return function');
    ok(p('Шла', 'по') === 'Шла Саша по шоссе undefined сосала', '.part with placeholders: args < placeholders');
    ok(p('Шла', 'по', 'и') === 'Шла Саша по шоссе и сосала', '.part with placeholders: args == placeholders');
    ok(p('Шла', 'по', 'и', 'сушку') === 'Шла Саша по шоссе и сосала сушку', '.part with placeholders: args > placeholders');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var global, ref$, from, values;
  QUnit.module('core-js');
  global = Function('return this')();
  ref$ = core.Array, from = ref$.from, values = ref$.values;
  test('core.getIteratorMethod', function(){
    var getIteratorMethod, iterFn, iter;
    getIteratorMethod = core.getIteratorMethod;
    ok(typeof getIteratorMethod === 'function', 'Is function');
    strictEqual(getIteratorMethod({}), void 8);
    iterFn = getIteratorMethod([]);
    ok(typeof iterFn === 'function');
    iter = iterFn.call([]);
    ok('next' in iter);
    iter = getIteratorMethod(function(){
      return arguments;
    }());
    ok(typeof iterFn === 'function');
    /*
    _Symbol = global.Symbol
    I = Math.random!
    O = {0: \a, 1: \b, 2: \c, length: 3}
    O[I] = -> values @
    strictEqual getIteratorMethod(O), void
    global.Symbol = {iterator: I}
    strictEqual getIteratorMethod(O), O[I]
    deepEqual from(getIteratorMethod(O).call O), <[a b c]>
    global.Symbol = _Symbol
    strictEqual getIteratorMethod(O), void
    */
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var global, ref$, from, values;
  QUnit.module('core-js');
  global = Function('return this')();
  ref$ = core.Array, from = ref$.from, values = ref$.values;
  test('core.getIterator', function(){
    var getIterator, iter;
    getIterator = core.getIterator;
    ok(typeof getIterator === 'function', 'Is function');
    throws(function(){
      getIterator({});
    }, TypeError);
    iter = getIterator([]);
    ok('next' in iter);
    iter = getIterator(function(){
      return arguments;
    }());
    ok('next' in iter);
    /*
    _Symbol = global.Symbol
    I = Math.random!
    O = {0: \a, 1: \b, 2: \c, length: 3}
    O[I] = -> values @
    throws (!-> getIterator O), TypeError
    global.Symbol = {iterator: I}
    try
      getIterator O
      ok on
    catch => ok no
    deepEqual from(getIterator O), <[a b c]>
    global.Symbol = _Symbol
    throws (!-> getIterator O), TypeError
    */
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var global, values;
  QUnit.module('core-js');
  global = Function('return this')();
  values = core.Array.values;
  test('core.isIterable', function(){
    var isIterable;
    isIterable = core.isIterable;
    ok(typeof isIterable === 'function', 'Is function');
    ok(!isIterable({}));
    ok(isIterable([]));
    ok(isIterable(function(){
      return arguments;
    }()));
    /*
    _Symbol = global.Symbol
    I = Math.random!
    o = {0: \a, 1: \b, 2: \c, length: 3}
    o[I] = -> values @
    ok !isIterable o
    global.Symbol = {iterator: I}
    ok isIterable o
    global.Symbol = _Symbol
    ok !isIterable o
    */
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, isObject, log, methods, toString$ = {}.toString;
  QUnit.module('core-js');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isObject = function(it){
    return it === Object(it);
  };
  log = core.log;
  methods = ['assert', 'count', 'debug', 'dir', 'dirxml', 'error', 'exception', 'group', 'groupEnd', 'groupCollapsed', 'groupEnd', 'info', 'log', 'table', 'trace', 'warn', 'markTimeline', 'profile', 'profileEnd', 'time', 'timeEnd', 'timeStamp'];
  test('is object', function(){
    ok(isObject(log), 'global.log is object');
  });
  test('log.{..} are functions', function(){
    var i$, x$, ref$, len$;
    for (i$ = 0, len$ = (ref$ = methods).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(isFunction(log[x$]), "log." + x$ + " is function");
    }
  });
  test('call log.{..}', function(){
    var i$, ref$, len$, m;
    for (i$ = 0, len$ = (ref$ = methods).length; i$ < len$; ++i$) {
      m = ref$[i$];
      ok((fn$()), "call log." + m);
    }
    function fn$(){
      try {
        if (m === 'profileEnd') {
          log[m]();
        } else {
          log[m]('foo');
        }
        return true;
      } catch (e$) {}
    }
  });
  test('call unbound log.#{..}', function(){
    var i$, ref$, len$, m;
    for (i$ = 0, len$ = (ref$ = methods).length; i$ < len$; ++i$) {
      m = ref$[i$];
      ok((fn$()), "call unbound log." + m);
    }
    function fn$(){
      try {
        if (m === 'profileEnd') {
          log[m].call(void 8);
        } else {
          log[m].call(void 8, 'foo');
        }
        return true;
      } catch (e$) {}
    }
  });
  test('log.{enable, disable}', function(){
    var enable, disable;
    enable = log.enable, disable = log.disable;
    ok(isFunction(enable), 'log.enable is function');
    ok(isFunction(disable), 'log.disable is function');
    ok((function(){
      try {
        disable();
        return true;
      } catch (e$) {}
    }()), 'disable log');
    ok((function(){
      try {
        return log.log('call disabled log') === void 8;
      } catch (e$) {}
    }()), 'call disabled log');
    ok((function(){
      try {
        enable();
        return true;
      } catch (e$) {}
    }()), 'enable log');
  });
  test('log', function(){
    ok(isFunction(log), 'global.log is function');
    ok((function(){
      try {
        log(42);
        return true;
      } catch (e$) {}
    }()), 'call log');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  QUnit.module('core-js');
  test('Number#@@iterator', function(){
    var getIterator, toStringTag, iter1, iter2, iter3, iter4, iter5, iter6;
    getIterator = core.getIterator;
    toStringTag = core.Symbol.toStringTag;
    iter1 = getIterator(2);
    ok(iter1[toStringTag] === 'Number Iterator', '@@toStringTag');
    deepEqual(iter1.next(), {
      done: false,
      value: 0
    }, '2 #1');
    deepEqual(iter1.next(), {
      done: false,
      value: 1
    }, '2 #2');
    deepEqual(iter1.next(), {
      done: true,
      value: void 8
    }, '2 #3');
    iter2 = getIterator(1.5);
    deepEqual(iter2.next(), {
      done: false,
      value: 0
    }, '1.5 #1');
    deepEqual(iter2.next(), {
      done: false,
      value: 1
    }, '1.5 #2');
    deepEqual(iter2.next(), {
      done: true,
      value: void 8
    }, '1.5 #3');
    iter3 = getIterator(-1);
    deepEqual(iter3.next(), {
      done: true,
      value: void 8
    }, '-1');
    iter4 = getIterator(NaN);
    deepEqual(iter4.next(), {
      done: true,
      value: void 8
    }, 'NaN');
    iter5 = getIterator(Infinity);
    deepEqual(iter5.next(), {
      done: false,
      value: 0
    }, 'Infinity #1');
    deepEqual(iter5.next(), {
      done: false,
      value: 1
    }, 'Infinity #1');
    deepEqual(iter5.next(), {
      done: false,
      value: 2
    }, 'Infinity #1');
    iter6 = getIterator(-Infinity);
    deepEqual(iter6.next(), {
      done: true,
      value: void 8
    }, '-Infinity');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('core-js');
  test('Object.classof', function(){
    var classof, Class;
    classof = core.Object.classof;
    ok(toString$.call(classof).slice(8, -1) === 'Function', 'Is function');
    ok(classof(void 8) === 'Undefined', 'classof undefined is `Undefined`');
    ok(classof(null) === 'Null', 'classof null is `Null`');
    ok(classof(true) === 'Boolean', 'classof bool is `Boolean`');
    ok(classof('string') === 'String', 'classof string is `String`');
    ok(classof(7) === 'Number', 'classof number is `Number`');
    ok(classof(core.Symbol()) === 'Symbol', 'classof symbol is `Symbol`');
    ok(classof(new Boolean(false)) === 'Boolean', 'classof new Boolean is `Boolean`');
    ok(classof(new String('')) === 'String', 'classof new String is `String`');
    ok(classof(new Number(7)) === 'Number', 'classof new Number is `Number`');
    ok(classof({}) === 'Object', 'classof {} is `Object`');
    ok(classof([]) === 'Array', 'classof array is `Array`');
    ok(classof(function(){}) === 'Function', 'classof function is `Function`');
    ok(classof(/./) === 'RegExp', 'classof regexp is `Undefined`');
    ok(classof(TypeError()) === 'Error', 'classof new TypeError is `RegExp`');
    ok(classof(function(){
      return arguments;
    }()) === 'Arguments', 'classof arguments list is `Arguments`');
    ok(classof(new core.Set) === 'Set', 'classof undefined is `Map`');
    ok(classof(new core.Map) === 'Map', 'classof map is `Undefined`');
    ok(classof(new core.WeakSet) === 'WeakSet', 'classof weakset is `WeakSet`');
    ok(classof(new core.WeakMap) === 'WeakMap', 'classof weakmap is `WeakMap`');
    ok(classof(new core.Promise(function(){})) === 'Promise', 'classof promise is `Promise`');
    ok(classof(core.getIterator('')) === 'String Iterator', 'classof String Iterator is `String Iterator`');
    ok(classof(core.getIterator([])) === 'Array Iterator', 'classof Array Iterator is `Array Iterator`');
    ok(classof(new core.Set().entries()) === 'Set Iterator', 'classof Set Iterator is `Set Iterator`');
    ok(classof(new core.Map().entries()) === 'Map Iterator', 'classof Map Iterator is `Map Iterator`');
    ok(classof(Math) === 'Math', 'classof Math is `Math`');
    if (typeof JSON != 'undefined' && JSON !== null) {
      ok(classof(JSON) === 'JSON', 'classof JSON is `JSON`');
    }
    Class = (function(){
      Class.displayName = 'Class';
      var prototype = Class.prototype, constructor = Class;
      Class.prototype[core.Symbol.toStringTag] = 'Class';
      function Class(){}
      return Class;
    }());
    ok(classof(new Class) === 'Class', 'classof user class is [Symbol.toStringTag]');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('core-js');
  test('Object.define', function(){
    var ref$, define, defineProperty, foo, foo2;
    ref$ = core.Object, define = ref$.define, defineProperty = ref$.defineProperty;
    ok(toString$.call(define).slice(8, -1) === 'Function', 'Is function');
    foo = {
      q: 1
    };
    ok(foo === define(foo, {
      w: 2
    }));
    ok(foo.w === 2);
    if (function(){
      try {
        return 2 === defineProperty({}, 'a', {
          get: function(){
            return 2;
          }
        }).a;
      } catch (e$) {}
    }()) {
      foo = {
        q: 1
      };
      foo2 = defineProperty({}, 'w', {
        get: function(){
          return this.q + 1;
        }
      });
      define(foo, foo2);
      ok(foo.w === 2);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('core-js');
  test('Object.isObject', function(){
    var isObject;
    isObject = core.Object.isObject;
    ok(toString$.call(isObject).slice(8, -1) === 'Function', 'Is function');
    ok(!isObject(void 8), 'isObject undefined return false');
    ok(!isObject(null), 'isObject null return false');
    ok(!isObject(1), 'isObject number return false');
    ok(!isObject(true), 'isObject bool return false');
    ok(!isObject('string'), 'isObject string return false');
    ok(isObject(new Number(1)), 'isObject new Number return true');
    ok(isObject(new Boolean(false)), 'isObject new Boolean return true');
    ok(isObject(new String(1)), 'isObject new String return true');
    ok(isObject({}), 'isObject object return true');
    ok(isObject([]), 'isObject array return true');
    ok(isObject(/./), 'isObject regexp return true');
    ok(isObject(function(){}), 'isObject function return true');
    ok(isObject(new function(){}), 'isObject constructor instance return true');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('core-js');
  test('Object.make', function(){
    var make, object, foo;
    make = core.Object.make;
    ok(toString$.call(make).slice(8, -1) === 'Function', 'Is function');
    object = make(foo = {
      q: 1
    }, {
      w: 2
    });
    ok(core.Object.getPrototypeOf(object) === foo);
    ok(object.w === 2);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('core-js');
  eq = strictEqual;
  test('String#escapeHTML', function(){
    var escapeHTML;
    escapeHTML = core.String.escapeHTML;
    ok(toString$.call(escapeHTML).slice(8, -1) === 'Function', 'Is function');
    eq(escapeHTML('qwe, asd'), 'qwe, asd');
    eq(escapeHTML('<div>qwe</div>'), '&lt;div&gt;qwe&lt;/div&gt;');
    eq(escapeHTML("&<>\"'"), '&amp;&lt;&gt;&quot;&apos;');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('core-js');
  eq = strictEqual;
  test('String#unescapeHTML', function(){
    var unescapeHTML;
    unescapeHTML = core.String.unescapeHTML;
    ok(toString$.call(unescapeHTML).slice(8, -1) === 'Function', 'Is function');
    eq(unescapeHTML('qwe, asd'), 'qwe, asd');
    eq(unescapeHTML('&lt;div&gt;qwe&lt;/div&gt;'), '<div>qwe</div>');
    eq(unescapeHTML('&amp;&lt;&gt;&quot;&apos;'), "&<>\"'");
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, eq, deq, toString$ = {}.toString;
  QUnit.module('ES5');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  eq = strictEqual;
  deq = deepEqual;
  test('Object.getOwnPropertyDescriptor', function(){
    var getOwnPropertyDescriptor;
    getOwnPropertyDescriptor = core.Object.getOwnPropertyDescriptor;
    ok(isFunction(getOwnPropertyDescriptor), 'Is function');
    deq(getOwnPropertyDescriptor({
      q: 42
    }, 'q'), {
      writable: true,
      enumerable: true,
      configurable: true,
      value: 42
    });
    ok(getOwnPropertyDescriptor({}, 'toString') === void 8);
  });
  test('Object.defineProperty', function(){
    var defineProperty, rez, src;
    defineProperty = core.Object.defineProperty;
    ok(isFunction(defineProperty), 'Is function');
    ok((rez = defineProperty(src = {}, 'q', {
      value: 42
    })) === src);
    ok(rez.q === 42);
  });
  test('Object.defineProperties', function(){
    var defineProperties, rez, src;
    defineProperties = core.Object.defineProperties;
    ok(isFunction(defineProperties), 'Is function');
    ok((rez = defineProperties(src = {}, {
      q: {
        value: 42
      },
      w: {
        value: 33
      }
    })) === src);
    ok(rez.q === 42) && rez.w === 33;
  });
  test('Object.getPrototypeOf', function(){
    var ref$, create, getPrototypeOf, fn, obj, foo, bar;
    ref$ = core.Object, create = ref$.create, getPrototypeOf = ref$.getPrototypeOf;
    ok(isFunction(getPrototypeOf), 'Is function');
    ok(getPrototypeOf({}) === Object.prototype);
    ok(getPrototypeOf([]) === Array.prototype);
    ok(getPrototypeOf(new (fn = (function(){
      fn.displayName = 'fn';
      var prototype = fn.prototype, constructor = fn;
      function fn(){}
      return fn;
    }()))) === fn.prototype);
    ok(getPrototypeOf(create(obj = {
      q: 1
    })) === obj);
    ok(getPrototypeOf(create(null)) === null);
    ok(getPrototypeOf(getPrototypeOf({})) === null);
    foo = function(){};
    foo.prototype.foo = 'foo';
    bar = function(){};
    bar.prototype = create(foo.prototype);
    bar.prototype.constructor = bar;
    eq(getPrototypeOf(bar.prototype).foo, 'foo');
  });
  test('Object.getOwnPropertyNames', function(){
    var getOwnPropertyNames, fn1, fn2;
    getOwnPropertyNames = core.Object.getOwnPropertyNames;
    ok(isFunction(getOwnPropertyNames), 'Is function');
    fn1 = function(w){
      this.w = w != null ? w : 2;
    };
    fn2 = function(toString){
      this.toString = toString != null ? toString : 2;
    };
    fn1.prototype.q = fn2.prototype.q = 1;
    deq(getOwnPropertyNames([1, 2, 3]), ['0', '1', '2', 'length']);
    deq(getOwnPropertyNames(new fn1(1)), ['w']);
    deq(getOwnPropertyNames(new fn2(1)), ['toString']);
    ok(in$('toString', getOwnPropertyNames(Array.prototype)));
    ok(in$('toString', getOwnPropertyNames(Object.prototype)));
    ok(in$('constructor', getOwnPropertyNames(Object.prototype)));
  });
  test('Object.create', function(){
    var ref$, create, getPrototypeOf, getOwnPropertyNames, isObject, isPrototype, getPropertyNames, obj, fn;
    ref$ = core.Object, create = ref$.create, getPrototypeOf = ref$.getPrototypeOf, getOwnPropertyNames = ref$.getOwnPropertyNames;
    isObject = function(it){
      return it === Object(it);
    };
    isPrototype = function(a, b){
      return {}.isPrototypeOf.call(a, b);
    };
    getPropertyNames = function(object){
      var result, i$, x$, ref$, len$;
      result = getOwnPropertyNames(object);
      while (object = getPrototypeOf(object)) {
        for (i$ = 0, len$ = (ref$ = getOwnPropertyNames(object)).length; i$ < len$; ++i$) {
          x$ = ref$[i$];
          in$(x$, result) || result.push(x$);
        }
      }
      return result;
    };
    ok(isFunction(create), 'Is function');
    ok(isPrototype(obj = {
      q: 1
    }, create(obj)));
    ok(create(obj).q === 1);
    fn = function(){
      return this.a = 1;
    };
    ok(create(new fn) instanceof fn);
    ok(fn.prototype === getPrototypeOf(getPrototypeOf(create(new fn))));
    ok(create(new fn).a === 1);
    ok(create({}, {
      a: {
        value: 42
      }
    }).a === 42);
    ok(isObject(obj = create(null, {
      w: {
        value: 2
      }
    })));
    ok(!('toString' in obj));
    ok(obj.w === 2);
    deq(getPropertyNames(create(null)), []);
  });
  test('Object.keys', function(){
    var keys, fn1, fn2;
    keys = core.Object.keys;
    ok(isFunction(keys), 'Is function');
    fn1 = function(w){
      this.w = w != null ? w : 2;
    };
    fn2 = function(toString){
      this.toString = toString != null ? toString : 2;
    };
    fn1.prototype.q = fn2.prototype.q = 1;
    deq(keys([1, 2, 3]), ['0', '1', '2']);
    deq(keys(new fn1(1)), ['w']);
    deq(keys(new fn2(1)), ['toString']);
    ok(!in$('push', keys(Array.prototype)));
  });
  test('Object.seal', function(){
    var seal, a;
    seal = core.Object.seal;
    ok(isFunction(seal), 'Is function');
    eq(seal(a = {}), a);
  });
  test('Object.freeze', function(){
    var freeze, a;
    freeze = core.Object.freeze;
    ok(isFunction(freeze), 'Is function');
    eq(freeze(a = {}), a);
  });
  test('Object.preventExtensions', function(){
    var preventExtensions, a;
    preventExtensions = core.Object.preventExtensions;
    ok(isFunction(preventExtensions), 'Is function');
    eq(preventExtensions(a = {}), a);
  });
  test('Object.isSealed', function(){
    var isSealed;
    isSealed = core.Object.isSealed;
    ok(isFunction(isSealed), 'Is function');
    eq(isSealed({}), false);
  });
  test('Object.isFrozen', function(){
    var isFrozen;
    isFrozen = core.Object.isFrozen;
    ok(isFunction(isFrozen), 'Is function');
    eq(isFrozen({}), false);
  });
  test('Object.isExtensible', function(){
    var isExtensible;
    isExtensible = core.Object.isExtensible;
    ok(isFunction(isExtensible), 'Is function');
    eq(isExtensible({}), true);
  });
  test('Function#bind', function(){
    var bind, obj, fn, inst, F, date;
    bind = core.Function.bind;
    ok(isFunction(bind), 'Is function');
    obj = {
      a: 42
    };
    ok(42 === bind(function(){
      return this.a;
    }, obj)());
    ok(void 8 === new (bind(function(){}, obj))().a);
    fn = function(a, b){
      this.a = a;
      this.b = b;
    };
    inst = new (bind(fn, null, 1))(2);
    ok(inst instanceof fn);
    eq(inst.a, 1);
    eq(inst.b, 2);
    ok(42 === bind(function(it){
      return it;
    }, null, 42)());
    fn = bind(RegExp.prototype.test, /a/);
    ok(fn('a'));
    F = bind(Date, null, 2015);
    date = new F(6);
    ok(date instanceof Date);
    eq(date.getFullYear(), 2015);
    eq(date.getMonth(), 6);
  });
  test('Array.isArray', function(){
    var isArray;
    isArray = core.Array.isArray;
    ok(isFunction(isArray), 'Is function');
    ok(!isArray({}));
    ok(!isArray(function(){
      return arguments;
    }()));
    ok(isArray([]));
  });
  test('ES5 Array prototype methods are functions', function(){
    var i$, x$, ref$, len$;
    for (i$ = 0, len$ = (ref$ = ['indexOf', 'lastIndexOf', 'every', 'some', 'forEach', 'map', 'filter', 'reduce', 'reduceRight']).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(isFunction(core.Array[x$]), "Array::" + x$ + " is function");
    }
  });
  test('Array#slice', function(){
    var slice, arr, str, list, ref$, e;
    slice = core.Array.slice;
    arr = ['1', '2', '3', '4', '5'];
    deq(slice(arr), arr);
    deq(slice(arr, 1, 3), ['2', '3']);
    deq(slice(arr, 1, void 8), ['2', '3', '4', '5']);
    deq(slice(arr, 1, -1), ['2', '3', '4']);
    deq(slice(arr, -2, -1), ['4']);
    deq(slice(arr, -2, -3), []);
    str = '12345';
    deq(slice(str), arr);
    deq(slice(str, 1, 3), ['2', '3']);
    deq(slice(str, 1, void 8), ['2', '3', '4', '5']);
    deq(slice(str, 1, -1), ['2', '3', '4']);
    deq(slice(str, -2, -1), ['4']);
    deq(slice(str, -2, -3), []);
    if (list = typeof document != 'undefined' && document !== null ? (ref$ = document.body) != null ? ref$.childNodes : void 8 : void 8) {
      try {
        eq(toString$.call(slice(list)).slice(8, -1), 'Array');
      } catch (e$) {
        e = e$;
        ok(false);
      }
    }
  });
  test('Array#join', function(){
    var join;
    join = core.Array.join;
    eq(join('123'), '1,2,3');
    eq(join('123', '|'), '1|2|3');
  });
  test('Array#indexOf', function(){
    var indexOf;
    indexOf = core.Array.indexOf;
    ok(0 === indexOf([1, 1, 1], 1));
    ok(-1 === indexOf([1, 2, 3], 1, 1));
    ok(1 === indexOf([1, 2, 3], 2, 1));
    ok(-1 === indexOf([NaN], NaN));
    ok(3 === indexOf(Array(2).concat([1, 2, 3]), 2));
    ok(-1 === indexOf(Array(1), void 8));
  });
  test('Array#lastIndexOf', function(){
    var lastIndexOf;
    lastIndexOf = core.Array.lastIndexOf;
    eq(2, lastIndexOf([1, 1, 1], 1));
    eq(-1, lastIndexOf([1, 2, 3], 3, 1));
    eq(1, lastIndexOf([1, 2, 3], 2, 1));
    eq(-1, lastIndexOf([NaN], NaN));
    eq(1, lastIndexOf([1, 2, 3].concat(Array(2)), 2));
  });
  test('Array#every', function(){
    var every, a, ctx, rez, arr;
    every = core.Array.every;
    every(a = [1], function(val, key, that){
      ok(val === 1);
      ok(key === 0);
      ok(that === a);
      return ok(this === ctx);
    }, ctx = {});
    ok(every([1, 2, 3], function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    ok(every([1, 2, 3], (function(it){
      return it < 4;
    })));
    ok(!every([1, 2, 3], (function(it){
      return it < 3;
    })));
    ok(!every([1, 2, 3], function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    ok(every([1, 2, 3], function(){
      return +this === 1;
    }, 1));
    rez = '';
    every([1, 2, 3], function(){
      return rez += arguments[1];
    });
    ok(rez === '012');
    ok(every(arr = [1, 2, 3], function(){
      return arguments[2] === arr;
    }));
  });
  test('Array#some', function(){
    var some, a, ctx, rez, arr;
    some = core.Array.some;
    some(a = [1], function(val, key, that){
      ok(val === 1);
      ok(key === 0);
      ok(that === a);
      return ok(this === ctx);
    }, ctx = {});
    ok(some([1, '2', 3], function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    ok(some([1, 2, 3], (function(it){
      return it < 3;
    })));
    ok(!some([1, 2, 3], (function(it){
      return it < 0;
    })));
    ok(!some([1, 2, 3], function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    ok(!some([1, 2, 3], function(){
      return +this !== 1;
    }, 1));
    rez = '';
    some([1, 2, 3], function(){
      rez += arguments[1];
      return false;
    });
    ok(rez === '012');
    ok(!some(arr = [1, 2, 3], function(){
      return arguments[2] !== arr;
    }));
  });
  test('Array#forEach', function(){
    var forEach, a, ctx, rez, arr;
    forEach = core.Array.forEach;
    forEach(a = [1], function(val, key, that){
      ok(val === 1);
      ok(key === 0);
      ok(that === a);
      ok(this === ctx);
    }, ctx = {});
    rez = '';
    forEach([1, 2, 3], function(it){
      rez += it;
    });
    ok(rez === '123');
    rez = '';
    forEach([1, 2, 3], function(){
      rez += arguments[1];
    });
    ok(rez === '012');
    rez = '';
    forEach([1, 2, 3], function(){
      rez += arguments[2];
    });
    ok(rez === '1,2,31,2,31,2,3');
    rez = '';
    forEach([1, 2, 3], function(){
      rez += this;
    }, 1);
    ok(rez === '111');
    rez = '';
    arr = [];
    arr[5] = '';
    forEach(arr, function(arg$, k){
      rez += k;
    });
    ok(rez === '5');
  });
  test('Array#map', function(){
    var map, a, ctx;
    map = core.Array.map;
    map(a = [1], function(val, key, that){
      ok(val === 1);
      ok(key === 0);
      ok(that === a);
      return ok(this === ctx);
    }, ctx = {});
    deq([2, 3, 4], map([1, 2, 3], (function(it){
      return it + 1;
    })));
    deq([1, 3, 5], map([1, 2, 3], curry$(function(x$, y$){
      return x$ + y$;
    })));
    deq([2, 2, 2], map([1, 2, 3], function(){
      return +this;
    }, 2));
  });
  test('Array#filter', function(){
    var filter, a, ctx;
    filter = core.Array.filter;
    filter(a = [1], function(val, key, that){
      ok(val === 1);
      ok(key === 0);
      ok(that === a);
      return ok(this === ctx);
    }, ctx = {});
    deq([1, 2, 3, 4, 5], filter([1, 2, 3, 'q', {}, 4, true, 5], function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
  });
  test('Array#reduce', function(){
    var reduce, a;
    reduce = core.Array.reduce;
    ok(-5 === reduce([5, 4, 3, 2, 1], curry$(function(x$, y$){
      return x$ - y$;
    })));
    reduce(a = [1], function(memo, val, key, that){
      ok(memo === 42);
      ok(val === 1);
      ok(key === 0);
      return ok(that === a);
    }, 42);
    reduce([42, 43], function(it){
      return ok(it === 42);
    });
  });
  test('Array#reduceRight', function(){
    var reduceRight, a;
    reduceRight = core.Array.reduceRight;
    ok(-5 === reduceRight([1, 2, 3, 4, 5], curry$(function(x$, y$){
      return x$ - y$;
    })));
    reduceRight(a = [1], function(memo, val, key, that){
      ok(memo === 42);
      ok(val === 1);
      ok(key === 0);
      return ok(that === a);
    }, 42);
    reduceRight([42, 43], function(it){
      return ok(it === 43);
    });
  });
  test('Date.now', function(){
    var now;
    now = core.Date.now;
    ok(isFunction(now), 'Is function');
    ok(+new Date - now() < 10, 'Date.now() ~ +new Date');
  });
  test('Date#toISOString', function(){
    var toISOString, ft, bc;
    toISOString = core.Date.toISOString;
    ok(isFunction(toISOString), 'Is function');
    eq(toISOString(new Date(0)), '1970-01-01T00:00:00.000Z');
    eq(toISOString(new Date(1e12 + 1)), '2001-09-09T01:46:40.001Z');
    eq(toISOString(new Date(-5e13 - 1)), '0385-07-25T07:06:39.999Z');
    ft = toISOString(new Date(1e15 + 1));
    ok(ft === '+033658-09-27T01:46:40.001Z' || ft === '33658-09-27T01:46:40.001Z');
    bc = toISOString(new Date(-1e15 + 1));
    ok(bc === '-029719-04-05T22:13:20.001Z' || bc === '-29719-04-05T22:13:20.001Z');
    throws(function(){
      return toISOString(new Date(NaN));
    }, RangeError);
  });
  function in$(x, xs){
    var i = -1, l = xs.length >>> 0;
    while (++i < l) if (x === xs[i]) return true;
    return false;
  }
  function curry$(f, bound){
    var context,
    _curry = function(args) {
      return f.length > 1 ? function(){
        var params = args ? args.concat() : [];
        context = bound ? context || this : this;
        return params.push.apply(params, arguments) <
            f.length && arguments.length ?
          _curry.call(context, params) : f.apply(context, params);
      } : f;
    };
    return _curry();
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var deq, toString$ = {}.toString;
  QUnit.module('ES6');
  deq = deepEqual;
  test('Array#copyWithin', function(){
    var copyWithin, a;
    copyWithin = core.Array.copyWithin;
    ok(toString$.call(copyWithin).slice(8, -1) === 'Function', 'Is function');
    strictEqual(a = copyWithin([1], 0), a);
    deq(copyWithin([1, 2, 3, 4, 5], 0, 3), [4, 5, 3, 4, 5]);
    deq(copyWithin([1, 2, 3, 4, 5], 1, 3), [1, 4, 5, 4, 5]);
    deq(copyWithin([1, 2, 3, 4, 5], 1, 2), [1, 3, 4, 5, 5]);
    deq(copyWithin([1, 2, 3, 4, 5], 2, 2), [1, 2, 3, 4, 5]);
    deq(copyWithin([1, 2, 3, 4, 5], 0, 3, 4), [4, 2, 3, 4, 5]);
    deq(copyWithin([1, 2, 3, 4, 5], 1, 3, 4), [1, 4, 3, 4, 5]);
    deq(copyWithin([1, 2, 3, 4, 5], 1, 2, 4), [1, 3, 4, 4, 5]);
    deq(copyWithin([1, 2, 3, 4, 5], 0, -2), [4, 5, 3, 4, 5]);
    deq(copyWithin([1, 2, 3, 4, 5], 0, -2, -1), [4, 2, 3, 4, 5]);
    deq(copyWithin([1, 2, 3, 4, 5], -4, -3, -2), [1, 3, 3, 4, 5]);
    deq(copyWithin([1, 2, 3, 4, 5], -4, -3, -1), [1, 3, 4, 4, 5]);
    deq(copyWithin([1, 2, 3, 4, 5], -4, -3), [1, 3, 4, 5, 5]);
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return copyWithin(null, 0);
      }, TypeError);
      throws(function(){
        return copyWithin(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var deq, toString$ = {}.toString;
  QUnit.module('ES6');
  deq = deepEqual;
  test('Array#fill', function(){
    var fill, a;
    fill = core.Array.fill;
    ok(toString$.call(fill).slice(8, -1) === 'Function', 'Is function');
    strictEqual(a = fill(Array(5), 5), a);
    deq(fill(Array(5), 5), [5, 5, 5, 5, 5]);
    deq(fill(Array(5), 5, 1), [void 8, 5, 5, 5, 5]);
    deq(fill(Array(5), 5, 1, 4), [void 8, 5, 5, 5, void 8]);
    deq(fill(Array(5), 5, 6, 1), [void 8, void 8, void 8, void 8, void 8]);
    deq(fill(Array(5), 5, -3, 4), [void 8, void 8, 5, 5, void 8]);
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return fill(null, 0);
      }, TypeError);
      throws(function(){
        return fill(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Array#findIndex', function(){
    var findIndex, arr, ctx;
    findIndex = core.Array.findIndex;
    ok(toString$.call(findIndex).slice(8, -1) === 'Function', 'Is function');
    findIndex(arr = [1], function(val, key, that){
      eq(this, ctx);
      eq(val, 1);
      eq(key, 0);
      return eq(that, arr);
    }, ctx = {});
    eq(findIndex([1, 3, NaN, 42, {}], (function(it){
      return it === 42;
    })), 3);
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return findIndex(null, 0);
      }, TypeError);
      throws(function(){
        return findIndex(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Array#find', function(){
    var find, arr, ctx;
    find = core.Array.find;
    ok(toString$.call(find).slice(8, -1) === 'Function', 'Is function');
    find(arr = [1], function(val, key, that){
      eq(this, ctx);
      eq(val, 1);
      eq(key, 0);
      return eq(that, arr);
    }, ctx = {});
    eq(find([1, 3, NaN, 42, {}], (function(it){
      return it === 42;
    })), 42);
    eq(find([1, 3, NaN, 42, {}], (function(it){
      return it === 43;
    })), void 8);
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return find(null, 0);
      }, TypeError);
      throws(function(){
        return find(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, deq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  deq = deepEqual;
  test('Array.from', function(){
    var ref$, from, values, iterator, al, ctx, done, iter, F, inst, a;
    ref$ = core.Array, from = ref$.from, values = ref$.values;
    iterator = core.Symbol.iterator;
    ok(toString$.call(from).slice(8, -1) === 'Function', 'Is function');
    eq(from.length, 1, 'length is 1');
    if ('name' in from) {
      eq(from.name, 'from', 'name is "from"');
    }
    deq(from('123'), ['1', '2', '3']);
    deq(from({
      length: 3,
      0: 1,
      1: 2,
      2: 3
    }), [1, 2, 3]);
    from(al = function(){
      return arguments;
    }(1), function(val, key){
      eq(this, ctx);
      eq(val, 1);
      return eq(key, 0);
    }, ctx = {});
    from([1], function(val, key){
      eq(this, ctx);
      eq(val, 1);
      return eq(key, 0);
    }, ctx = {});
    deq(from({
      length: 3,
      0: 1,
      1: 2,
      2: 3
    }, (function(it){
      return Math.pow(it, 2);
    })), [1, 4, 9]);
    deq(from(new core.Set([1, 2, 3, 2, 1])), [1, 2, 3], 'Works with iterators');
    throws(function(){
      return from(null);
    }, TypeError);
    throws(function(){
      return from(void 8);
    }, TypeError);
    done = true;
    iter = values([1, 2, 3]);
    iter['return'] = function(){
      return done = false;
    };
    from(iter, function(){
      return false;
    });
    ok(done, '.return #default');
    done = false;
    iter = values([1, 2, 3]);
    iter['return'] = function(){
      return done = true;
    };
    try {
      from(iter, function(){
        throw 42;
      });
    } catch (e$) {}
    ok(done, '.return #throw');
    F = function(){};
    inst = from.call(F, [1, 2]);
    ok(inst instanceof F);
    eq(inst[0], 1);
    eq(inst[1], 2);
    eq(inst.length, 2);
    inst = from.call(F, {
      0: 1,
      1: 2,
      length: 2
    });
    ok(inst instanceof F);
    eq(inst[0], 1);
    eq(inst[1], 2);
    eq(inst.length, 2);
    a = [1, 2, 3];
    done = false;
    a['@@iterator'] = void 8;
    a[iterator] = function(){
      done = true;
      return core.getIteratorMethod([]).call(this);
    };
    deq(from(a), [1, 2, 3]);
    ok(done);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, deq, isFunction, isIterator, Symbol, ref$, keys, values, entries, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  deq = deepEqual;
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isIterator = function(it){
    return typeof it === 'object' && isFunction(it.next);
  };
  Symbol = core.Symbol;
  ref$ = core.Array, keys = ref$.keys, values = ref$.values, entries = ref$.entries;
  test('Array#@@iterator', function(){
    var iter;
    ok(isFunction(values), 'Is function');
    iter = core.getIterator(['q', 'w', 'e']);
    ok(isIterator(iter), 'Return iterator');
    eq(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Array Iterator');
    deq(iter.next(), {
      value: 'q',
      done: false
    });
    deq(iter.next(), {
      value: 'w',
      done: false
    });
    deq(iter.next(), {
      value: 'e',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Array#keys', function(){
    var iter;
    ok(isFunction(keys), 'Is function');
    iter = keys(['q', 'w', 'e']);
    ok(isIterator(iter), 'Return iterator');
    eq(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Array Iterator');
    deq(iter.next(), {
      value: 0,
      done: false
    });
    deq(iter.next(), {
      value: 1,
      done: false
    });
    deq(iter.next(), {
      value: 2,
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Array#values', function(){
    var iter;
    ok(isFunction(values), 'Is function');
    iter = values(['q', 'w', 'e']);
    ok(isIterator(iter), 'Return iterator');
    eq(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Array Iterator');
    deq(iter.next(), {
      value: 'q',
      done: false
    });
    deq(iter.next(), {
      value: 'w',
      done: false
    });
    deq(iter.next(), {
      value: 'e',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Array#entries', function(){
    var iter;
    ok(isFunction(entries), 'Is function');
    iter = entries(['q', 'w', 'e']);
    ok(isIterator(iter), 'Return iterator');
    eq(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Array Iterator');
    deq(iter.next(), {
      value: [0, 'q'],
      done: false
    });
    deq(iter.next(), {
      value: [1, 'w'],
      done: false
    });
    deq(iter.next(), {
      value: [2, 'e'],
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, deq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  deq = deepEqual;
  test('Array.of', function(){
    var F, inst;
    ok(toString$.call(core.Array.of).slice(8, -1) === 'Function', 'Is function');
    eq(core.Array.of.length, 0, 'length is 0');
    if ('name' in core.Array.of) {
      eq(core.Array.of.name, 'of', 'name is "of"');
    }
    deq(core.Array.of(1), [1]);
    deq(core.Array.of(1, 2, 3), [1, 2, 3]);
    F = function(){};
    inst = core.Array.of.call(F, 1, 2);
    ok(inst instanceof F);
    eq(inst[0], 1);
    eq(inst[1], 2);
    eq(inst.length, 2);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  QUnit.module('ES6');
  test('Function#@@hasInstance', function(){
    ok(core.Symbol.hasInstance in Function.prototype);
    ok(Function[core.Symbol.hasInstance](function(){}));
    ok(!Function[core.Symbol.hasInstance]({}));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, isIterator, same, Map, Symbol, ref$, getOwnPropertyDescriptor, freeze, entries, values, iterator, eq, deq, toString$ = {}.toString;
  QUnit.module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isIterator = function(it){
    return typeof it === 'object' && isFunction(it.next);
  };
  same = function(a, b){
    if (a === b) {
      return a !== 0 || 1 / a === 1 / b;
    } else {
      return a != a && b != b;
    }
  };
  Map = core.Map, Symbol = core.Symbol;
  ref$ = core.Object, getOwnPropertyDescriptor = ref$.getOwnPropertyDescriptor, freeze = ref$.freeze;
  ref$ = core.Array, entries = ref$.entries, values = ref$.values;
  iterator = core.Symbol.iterator;
  eq = strictEqual;
  deq = deepEqual;
  test('Map', function(){
    var done, iter, a;
    ok(isFunction(Map), 'Is function');
    ok('clear' in Map.prototype, 'clear in Map.prototype');
    ok('delete' in Map.prototype, 'delete in Map.prototype');
    ok('forEach' in Map.prototype, 'forEach in Map.prototype');
    ok('get' in Map.prototype, 'get in Map.prototype');
    ok('has' in Map.prototype, 'has in Map.prototype');
    ok('set' in Map.prototype, 'set in Map.prototype');
    ok(new Map instanceof Map, 'new Map instanceof Map');
    eq(new Map(entries([1, 2, 3])).size, 3, 'Init from iterator #1');
    eq(new Map(new Map(entries([1, 2, 3]))).size, 3, 'Init from iterator #2');
    eq(new Map([[freeze({}), 1], [2, 3]]).size, 2, 'Support frozen objects');
    done = false;
    iter = values([null, 1, 2]);
    iter['return'] = function(){
      return done = true;
    };
    try {
      new Map(iter);
    } catch (e$) {}
    ok(done, '.return #throw');
    a = [];
    done = false;
    a['@@iterator'] = void 8;
    a[iterator] = function(){
      done = true;
      return core.getIteratorMethod([]).call(this);
    };
    new Map(a);
    ok(done);
  });
  test('Map#clear', function(){
    var M, f;
    ok(isFunction(Map.prototype.clear), 'Is function');
    M = new Map;
    M.clear();
    eq(M.size, 0);
    M = new Map().set(1, 2).set(2, 3).set(1, 4);
    M.clear();
    eq(M.size, 0);
    ok(!M.has(1));
    ok(!M.has(2));
    M = new Map().set(1, 2).set(f = freeze({}), 3);
    M.clear();
    eq(M.size, 0, 'Support frozen objects');
    ok(!M.has(1));
    ok(!M.has(f));
  });
  test('Map#delete', function(){
    var a, M, f;
    ok(isFunction(Map.prototype['delete']), 'Is function');
    a = [];
    M = new Map().set(NaN, 1).set(2, 1).set(3, 1).set(2, 5).set(1, 4).set(a, {});
    eq(M.size, 5);
    ok(M['delete'](NaN));
    eq(M.size, 4);
    ok(!M['delete'](4));
    eq(M.size, 4);
    M['delete']([]);
    eq(M.size, 4);
    M['delete'](a);
    eq(M.size, 3);
    M.set(freeze(f = {}), 42);
    eq(M.size, 4);
    M['delete'](f);
    eq(M.size, 3);
  });
  test('Map#forEach', function(){
    var r, T, count, M, a, map, s;
    ok(isFunction(Map.prototype.forEach), 'Is function');
    r = {};
    count = 0;
    M = new Map().set(NaN, 1).set(2, 1).set(3, 7).set(2, 5).set(1, 4).set(a = {}, 9);
    M.forEach(function(value, key){
      count++;
      r[value] = key;
    });
    eq(count, 5);
    deq(r, {
      1: NaN,
      7: 3,
      5: 2,
      4: 1,
      9: a
    });
    map = new Map([['0', 9], ['1', 9], ['2', 9], ['3', 9]]);
    s = "";
    map.forEach(function(value, key){
      s += key;
      if (key === '2') {
        map['delete']('2');
        map['delete']('3');
        map['delete']('1');
        return map.set('4', 9);
      }
    });
    eq(s, '0124');
    map = new Map([['0', 1]]);
    s = "";
    map.forEach(function(it){
      map['delete']('0');
      if (s !== '') {
        throw '!!!';
      }
      return s += it;
    });
    eq(s, '1');
  });
  test('Map#get', function(){
    var o, f, M;
    ok(isFunction(Map.prototype.get), 'Is function');
    o = {};
    f = freeze({});
    M = new Map([[NaN, 1], [2, 1], [3, 1], [2, 5], [1, 4], [f, 42], [o, o]]);
    eq(M.get(NaN), 1);
    eq(M.get(4), void 8);
    eq(M.get({}), void 8);
    eq(M.get(o), o);
    eq(M.get(f), 42);
    eq(M.get(2), 5);
  });
  test('Map#has', function(){
    var o, f, M;
    ok(isFunction(Map.prototype.has), 'Is function');
    o = {};
    f = freeze({});
    M = new Map([[NaN, 1], [2, 1], [3, 1], [2, 5], [1, 4], [f, 42], [o, o]]);
    ok(M.has(NaN));
    ok(M.has(o));
    ok(M.has(2));
    ok(M.has(f));
    ok(!M.has(4));
    ok(!M.has({}));
  });
  test('Map#set', function(){
    var o, M, chain, f;
    ok(isFunction(Map.prototype.set), 'Is function');
    o = {};
    M = new Map().set(NaN, 1).set(2, 1).set(3, 1).set(2, 5).set(1, 4).set(o, o);
    ok(M.size === 5);
    chain = M.set(7, 2);
    eq(chain, M);
    M.set(7, 2);
    eq(M.size, 6);
    eq(M.get(7), 2);
    eq(M.get(NaN), 1);
    M.set(NaN, 42);
    eq(M.size, 6);
    eq(M.get(NaN), 42);
    M.set({}, 11);
    eq(M.size, 7);
    eq(M.get(o), o);
    M.set(o, 27);
    eq(M.size, 7);
    eq(M.get(o), 27);
    eq(new Map().set(NaN, 2).set(NaN, 3).set(NaN, 4).size, 1);
    M = new Map().set(freeze(f = {}), 42);
    eq(M.get(f), 42);
  });
  test('Map#size', function(){
    var size, sizeDesc;
    size = new Map().set(2, 1).size;
    eq(typeof size, 'number', 'size is number');
    eq(size, 1, 'size is correct');
    if (function(){
      try {
        return 2 === core.Object.defineProperty({}, 'a', {
          get: function(){
            return 2;
          }
        }).a;
      } catch (e$) {}
    }()) {
      sizeDesc = getOwnPropertyDescriptor(Map.prototype, 'size');
      ok(sizeDesc && sizeDesc.get, 'size is getter');
      ok(sizeDesc && !sizeDesc.set, 'size isnt setter');
      throws(function(){
        return Map.prototype.size;
      }, TypeError);
    }
  });
  test('Map & -0', function(){
    var map;
    map = new Map;
    map.set(-0, 1);
    eq(map.size, 1);
    ok(map.has(0));
    ok(map.has(-0));
    eq(map.get(0), 1);
    eq(map.get(-0), 1);
    map.forEach(function(val, key){
      return ok(!same(key, -0));
    });
    map['delete'](-0);
    eq(map.size, 0);
    map = new Map([[-0, 1]]);
    map.forEach(function(val, key){
      return ok(!same(key, -0));
    });
  });
  test('Map#@@toStringTag', function(){
    eq(Map.prototype[Symbol != null ? Symbol.toStringTag : void 8], 'Map', 'Map::@@toStringTag is `Map`');
  });
  test('Map Iterator', function(){
    var map, keys, iterator;
    map = new Map([['a', 1], ['b', 2], ['c', 3], ['d', 4]]);
    keys = [];
    iterator = map.keys();
    keys.push(iterator.next().value);
    ok(map['delete']('a'));
    ok(map['delete']('b'));
    ok(map['delete']('c'));
    map.set('e');
    keys.push(iterator.next().value);
    keys.push(iterator.next().value);
    ok(iterator.next().done);
    map.set('f');
    ok(iterator.next().done);
    deq(keys, ['a', 'd', 'e']);
  });
  test('Map#keys', function(){
    var iter;
    ok(typeof Map.prototype.keys === 'function', 'Is function');
    iter = new Map([['a', 'q'], ['s', 'w'], ['d', 'e']]).keys();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Map Iterator');
    deq(iter.next(), {
      value: 'a',
      done: false
    });
    deq(iter.next(), {
      value: 's',
      done: false
    });
    deq(iter.next(), {
      value: 'd',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Map#values', function(){
    var iter;
    ok(typeof Map.prototype.values === 'function', 'Is function');
    iter = new Map([['a', 'q'], ['s', 'w'], ['d', 'e']]).values();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Map Iterator');
    deq(iter.next(), {
      value: 'q',
      done: false
    });
    deq(iter.next(), {
      value: 'w',
      done: false
    });
    deq(iter.next(), {
      value: 'e',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Map#entries', function(){
    var iter;
    ok(typeof Map.prototype.entries === 'function', 'Is function');
    iter = new Map([['a', 'q'], ['s', 'w'], ['d', 'e']]).entries();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Map Iterator');
    deq(iter.next(), {
      value: ['a', 'q'],
      done: false
    });
    deq(iter.next(), {
      value: ['s', 'w'],
      done: false
    });
    deq(iter.next(), {
      value: ['d', 'e'],
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Map#@@iterator', function(){
    var iter;
    iter = core.getIterator(new Map([['a', 'q'], ['s', 'w'], ['d', 'e']]));
    ok(isIterator(iter), 'Return iterator');
    eq(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Map Iterator');
    deq(iter.next(), {
      value: ['a', 'q'],
      done: false
    });
    deq(iter.next(), {
      value: ['s', 'w'],
      done: false
    });
    deq(iter.next(), {
      value: ['d', 'e'],
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.acosh', function(){
    var acosh;
    acosh = core.Math.acosh;
    ok(isFunction(acosh), 'Is function');
    sameEq(acosh(NaN), NaN);
    sameEq(acosh(0.5), NaN);
    sameEq(acosh(-1), NaN);
    sameEq(acosh(-1e300), NaN);
    sameEq(acosh(1), 0);
    eq(acosh(Infinity), Infinity);
    ok(epsilon(acosh(1234), 7.811163220849231));
    ok(epsilon(acosh(8.88), 2.8737631531629235));
    ok(acosh(1e+160), 369.10676205960726);
    ok(epsilon(acosh(Number.MAX_VALUE), 710.475860073944));
    ok(epsilon(acosh(1 + core.Number.EPSILON), 2.1073424255447017e-8));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.asinh', function(){
    var asinh;
    asinh = core.Math.asinh;
    ok(isFunction(asinh), 'Is function');
    sameEq(asinh(NaN), NaN);
    sameEq(asinh(0), 0);
    sameEq(asinh(-0), -0);
    eq(asinh(Infinity), Infinity);
    eq(asinh(-Infinity), -Infinity);
    ok(epsilon(asinh(1234), 7.811163549201245));
    ok(epsilon(asinh(9.99), 2.997227420191335));
    ok(epsilon(asinh(1e150), 346.0809111296668));
    ok(epsilon(asinh(1e7), 16.811242831518268));
    ok(epsilon(asinh(-1e7), -16.811242831518268));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.atanh', function(){
    var atanh;
    atanh = core.Math.atanh;
    ok(isFunction(atanh), 'Is function');
    sameEq(atanh(NaN), NaN);
    sameEq(atanh(-2), NaN);
    sameEq(atanh(-1.5), NaN);
    sameEq(atanh(2), NaN);
    sameEq(atanh(1.5), NaN);
    eq(atanh(-1), -Infinity);
    eq(atanh(1), Infinity);
    sameEq(atanh(0), 0);
    sameEq(atanh(-0), -0);
    sameEq(atanh(-1e300), NaN);
    sameEq(atanh(1e300), NaN);
    ok(epsilon(atanh(0.5), 0.5493061443340549));
    ok(epsilon(atanh(-0.5), -0.5493061443340549));
    ok(epsilon(atanh(0.444), 0.47720201260109457));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.cbrt', function(){
    var cbrt;
    cbrt = core.Math.cbrt;
    ok(isFunction(cbrt), 'Is function');
    sameEq(cbrt(NaN), NaN);
    sameEq(cbrt(0), 0);
    sameEq(cbrt(-0), -0);
    eq(cbrt(Infinity), Infinity);
    eq(cbrt(-Infinity), -Infinity);
    eq(cbrt(-8), -2);
    eq(cbrt(8), 2);
    ok(epsilon(cbrt(-1000), -10));
    ok(epsilon(cbrt(1000), 10));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  test('Math.clz32', function(){
    var clz32;
    clz32 = core.Math.clz32;
    ok(isFunction(clz32), 'Is function');
    eq(clz32(0), 32);
    eq(clz32(1), 31);
    sameEq(clz32(-1), 0);
    eq(clz32(0.6), 32);
    sameEq(clz32(Math.pow(2, 32) - 1), 0);
    eq(clz32(Math.pow(2, 32)), 32);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.cosh', function(){
    var cosh;
    cosh = core.Math.cosh;
    ok(isFunction(cosh), 'Is function');
    sameEq(cosh(NaN), NaN);
    eq(cosh(0), 1);
    eq(cosh(-0), 1);
    eq(cosh(Infinity), Infinity);
    eq(cosh(-Infinity), Infinity);
    ok(epsilon(cosh(12), 81377.39571257407, 3e-11));
    ok(epsilon(cosh(22), 1792456423.065795780980053377, 1e-5));
    ok(epsilon(cosh(-10), 11013.23292010332313972137));
    ok(epsilon(cosh(-23), 4872401723.1244513000, 1e-5));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.expm1', function(){
    var expm1;
    expm1 = core.Math.expm1;
    ok(isFunction(expm1), 'Is function');
    sameEq(expm1(NaN), NaN);
    sameEq(expm1(0), 0);
    sameEq(expm1(-0), -0);
    eq(expm1(Infinity), Infinity);
    eq(expm1(-Infinity), -1);
    ok(epsilon(expm1(10), 22025.465794806718, ok(epsilon(expm1(-10), -0.9999546000702375))));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  test('Math.fround', function(){
    var fround, maxFloat32, minFloat32;
    fround = core.Math.fround;
    ok(isFunction(fround), 'Is function');
    sameEq(fround(void 8), NaN);
    sameEq(fround(NaN), NaN);
    sameEq(fround(0), 0);
    sameEq(fround(-0), -0);
    sameEq(fround(Number.MIN_VALUE), 0);
    sameEq(fround(-Number.MIN_VALUE), -0);
    eq(fround(Infinity), Infinity);
    eq(fround(-Infinity), -Infinity);
    eq(fround(1.7976931348623157e+308), Infinity);
    eq(fround(-1.7976931348623157e+308), -Infinity);
    eq(fround(3.4028235677973366e+38), Infinity);
    eq(fround(3), 3);
    eq(fround(-3), -3);
    maxFloat32 = 3.4028234663852886e+38;
    minFloat32 = 1.401298464324817e-45;
    eq(fround(maxFloat32), maxFloat32);
    eq(fround(-maxFloat32), -maxFloat32);
    eq(fround(maxFloat32 + Math.pow(2, Math.pow(2, 8 - 1) - 1 - 23 - 2)), maxFloat32);
    eq(fround(minFloat32), minFloat32);
    eq(fround(-minFloat32), -minFloat32);
    sameEq(fround(minFloat32 / 2), 0);
    sameEq(fround(-minFloat32 / 2), -0);
    eq(fround(minFloat32 / 2 + Math.pow(2, -202)), minFloat32);
    eq(fround(-minFloat32 / 2 - Math.pow(2, -202)), -minFloat32);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.hypot', function(){
    var sqrt, hypot;
    sqrt = Math.sqrt;
    hypot = core.Math.hypot;
    ok(isFunction(hypot), 'Is function');
    eq(hypot(), 0);
    eq(hypot(1), 1);
    sameEq(hypot('', 0), 0);
    sameEq(hypot(0, ''), 0);
    eq(hypot(Infinity, 0), Infinity);
    eq(hypot(-Infinity, 0), Infinity);
    eq(hypot(0, Infinity), Infinity);
    eq(hypot(0, -Infinity), Infinity);
    eq(hypot(Infinity, NaN), Infinity);
    eq(hypot(NaN, -Infinity), Infinity);
    sameEq(hypot(NaN, 0), NaN);
    sameEq(hypot(0, NaN), NaN);
    sameEq(hypot(0, -0), 0);
    sameEq(hypot(0, 0), 0);
    sameEq(hypot(-0, -0), 0);
    sameEq(hypot(-0, 0), 0);
    eq(hypot(0, 1), 1);
    eq(hypot(0, -1), 1);
    eq(hypot(-0, 1), 1);
    eq(hypot(-0, -1), 1);
    sameEq(hypot(0), 0);
    eq(hypot(1), 1);
    eq(hypot(2), 2);
    eq(hypot(0, 0, 1), 1);
    eq(hypot(0, 1, 0), 1);
    eq(hypot(1, 0, 0), 1);
    eq(hypot(2, 3, 4), sqrt(2 * 2 + 3 * 3 + 4 * 4));
    eq(hypot(2, 3, 4, 5), sqrt(2 * 2 + 3 * 3 + 4 * 4 + 5 * 5));
    ok(epsilon(hypot(66, 66), 93.33809511662427));
    ok(epsilon(hypot(0.1, 100), 100.0000499999875));
    eq(hypot(1e+300, 1e+300), 1.4142135623730952e+300);
    eq(Math.floor(hypot(1e-300, 1e-300) * 1e308), 141421356);
    eq(hypot(1e+300, 1e+300, 2, 3), 1.4142135623730952e+300);
    eq(hypot(-3, 4), 5);
    eq(hypot(3, -4), 5);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  test('Math.imul', function(){
    var imul;
    imul = core.Math.imul;
    ok(isFunction(imul), 'Is function');
    sameEq(imul(0, 0), 0);
    eq(imul(123, 456), 56088);
    eq(imul(-123, 456), -56088);
    eq(imul(123, -456), -56088);
    eq(imul(19088743, 4275878552), 602016552);
    sameEq(imul(false, 7), 0);
    sameEq(imul(7, false), 0);
    sameEq(imul(false, false), 0);
    eq(imul(true, 7), 7);
    eq(imul(7, true), 7);
    eq(imul(true, true), 1);
    sameEq(imul(void 8, 7), 0);
    sameEq(imul(7, void 8), 0);
    sameEq(imul(void 8, void 8), 0);
    sameEq(imul('str', 7), 0);
    sameEq(imul(7, 'str'), 0);
    sameEq(imul({}, 7), 0);
    sameEq(imul(7, {}), 0);
    sameEq(imul([], 7), 0);
    sameEq(imul(7, []), 0);
    eq(imul(0xffffffff, 5), -5);
    eq(imul(0xfffffffe, 5), -10);
    eq(imul(2, 4), 8);
    eq(imul(-1, 8), -8);
    eq(imul(-2, -2), 4);
    sameEq(imul(-0, 7), 0);
    sameEq(imul(7, -0), 0);
    sameEq(imul(0.1, 7), 0);
    sameEq(imul(7, 0.1), 0);
    sameEq(imul(0.9, 7), 0);
    sameEq(imul(7, 0.9), 0);
    eq(imul(1.1, 7), 7);
    eq(imul(7, 1.1), 7);
    eq(imul(1.9, 7), 7);
    eq(imul(7, 1.9), 7);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.log10', function(){
    var log10;
    log10 = core.Math.log10;
    ok(isFunction(log10), 'Is function');
    sameEq(log10(''), log10(0));
    sameEq(log10(NaN), NaN);
    sameEq(log10(-1), NaN);
    sameEq(log10(0), -Infinity);
    sameEq(log10(-0), -Infinity);
    sameEq(log10(1), 0);
    sameEq(log10(Infinity), Infinity);
    ok(epsilon(log10(0.1), -1));
    ok(epsilon(log10(0.5), -0.3010299956639812));
    ok(epsilon(log10(1.5), 0.17609125905568124));
    ok(epsilon(log10(5), 0.6989700043360189));
    ok(epsilon(log10(50), 1.6989700043360187));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.log1p', function(){
    var log1p;
    log1p = core.Math.log1p;
    ok(isFunction(log1p), 'Is function');
    sameEq(log1p(''), log1p(0));
    sameEq(log1p(NaN), NaN);
    sameEq(log1p(-2), NaN);
    sameEq(log1p(-1), -Infinity);
    sameEq(log1p(0), 0);
    sameEq(log1p(-0), -0);
    sameEq(log1p(Infinity), Infinity);
    ok(epsilon(log1p(5), 1.791759469228055));
    ok(epsilon(log1p(50), 3.9318256327243257));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.log2', function(){
    var log2;
    log2 = core.Math.log2;
    ok(isFunction(log2), 'Is function');
    sameEq(log2(''), log2(0));
    sameEq(log2(NaN), NaN);
    sameEq(log2(-1), NaN);
    sameEq(log2(0), -Infinity);
    sameEq(log2(-0), -Infinity);
    sameEq(log2(1), 0);
    sameEq(log2(Infinity), Infinity);
    sameEq(log2(0.5), -1);
    sameEq(log2(32), 5);
    ok(epsilon(log2(5), 2.321928094887362));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  test('Math.sign', function(){
    var sign;
    sign = core.Math.sign;
    ok(isFunction(sign), 'Is function');
    sameEq(sign(NaN), NaN);
    sameEq(sign(), NaN);
    sameEq(sign(-0), -0);
    sameEq(sign(0), 0);
    eq(sign(Infinity), 1);
    eq(sign(-Infinity), -1);
    eq(sign(13510798882111488), 1);
    eq(sign(-13510798882111488), -1);
    eq(sign(42.5), 1);
    eq(sign(-42.5), -1);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.sinh', function(){
    var sinh;
    sinh = core.Math.sinh;
    ok(isFunction(sinh), 'Is function');
    sameEq(sinh(NaN), NaN);
    sameEq(sinh(0), 0);
    sameEq(sinh(-0), -0);
    eq(sinh(Infinity), Infinity);
    eq(sinh(-Infinity), -Infinity);
    ok(epsilon(sinh(-5), -74.20321057778875));
    ok(epsilon(sinh(2), 3.6268604078470186));
    eq(sinh(-2e-17), -2e-17);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.tanh', function(){
    var tanh;
    tanh = core.Math.tanh;
    ok(isFunction(tanh), 'Is function');
    sameEq(tanh(NaN), NaN);
    sameEq(tanh(0), 0);
    sameEq(tanh(-0), -0);
    eq(tanh(Infinity), 1);
    eq(tanh(90), 1);
    ok(epsilon(tanh(10), 0.9999999958776927));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  test('Math.trunc', function(){
    var trunc;
    trunc = core.Math.trunc;
    ok(isFunction(trunc), 'Is function');
    sameEq(trunc(NaN), NaN, 'NaN -> NaN');
    sameEq(trunc(-0), -0, '-0 -> -0');
    sameEq(trunc(0), 0, '0 -> 0');
    sameEq(trunc(Infinity), Infinity, 'Infinity -> Infinity');
    sameEq(trunc(-Infinity), -Infinity, '-Infinity -> -Infinity');
    sameEq(trunc(null), 0, 'null -> 0');
    sameEq(trunc({}), NaN, '{} -> NaN');
    eq(trunc([]), 0, '[] -> 0');
    eq(trunc(1.01), 1, '1.01 -> 0');
    eq(trunc(1.99), 1, '1.99 -> 0');
    eq(trunc(-1), -1, '-1 -> -1');
    eq(trunc(-1.99), -1, '-1.99 -> -1');
    eq(trunc(-555.555), -555, '-555.555 -> -555');
    eq(trunc(0x20000000000001), 0x20000000000001, '0x20000000000001 -> 0x20000000000001');
    eq(trunc(-0x20000000000001), -0x20000000000001, '-0x20000000000001 -> -0x20000000000001');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Number.EPSILON', function(){
    var EPSILON;
    EPSILON = core.Number.EPSILON;
    ok('EPSILON' in core.Number, 'EPSILON in Number');
    eq(EPSILON, Math.pow(2, -52), 'Is 2^-52');
    ok(1 !== 1 + EPSILON, '1 isnt 1 + EPSILON');
    eq(1, 1 + EPSILON / 2, '1 is 1 + EPSILON / 2');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('Number.isFinite', function(){
    var isFinite, create, i$, x$, ref$, len$, y$, e;
    isFinite = core.Number.isFinite;
    create = core.Object.create;
    ok(toString$.call(isFinite).slice(8, -1) === 'Function', 'Is function');
    for (i$ = 0, len$ = (ref$ = [1, 0.1, -1, Math.pow(2, 16), Math.pow(2, 16) - 1, Math.pow(2, 31), Math.pow(2, 31) - 1, Math.pow(2, 32), Math.pow(2, 32) - 1, -0]).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(isFinite(x$), "isFinite " + typeof x$ + " " + x$);
    }
    for (i$ = 0, len$ = (ref$ = [NaN, Infinity, 'NaN', '5', false, new Number(NaN), new Number(Infinity), new Number(5), new Number(0.1), void 8, null, {}, fn$, create(null)]).length; i$ < len$; ++i$) {
      y$ = ref$[i$];
      ok(!isFinite(y$), "not isFinite " + typeof y$ + " " + (fn1$()));
    }
    function fn$(){}
    function fn1$(){
      try {
        return String(y$);
      } catch (e$) {
        e = e$;
        return 'Object.create(null)';
      }
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('Number.isInteger', function(){
    var isInteger, create, i$, x$, ref$, len$, y$, e;
    isInteger = core.Number.isInteger;
    create = core.Object.create;
    ok(toString$.call(isInteger).slice(8, -1) === 'Function', 'Is function');
    for (i$ = 0, len$ = (ref$ = [1, -1, Math.pow(2, 16), Math.pow(2, 16) - 1, Math.pow(2, 31), Math.pow(2, 31) - 1, Math.pow(2, 32), Math.pow(2, 32) - 1, -0]).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(isInteger(x$), "isInteger " + typeof x$ + " " + x$);
    }
    for (i$ = 0, len$ = (ref$ = [NaN, 0.1, Infinity, 'NaN', '5', false, new Number(NaN), new Number(Infinity), new Number(5), new Number(0.1), void 8, null, {}, fn$, create(null)]).length; i$ < len$; ++i$) {
      y$ = ref$[i$];
      ok(!isInteger(y$), "not isInteger " + typeof y$ + " " + (fn1$()));
    }
    function fn$(){}
    function fn1$(){
      try {
        return String(y$);
      } catch (e$) {
        e = e$;
        return 'Object.create(null)';
      }
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('Number.isNaN', function(){
    var isNaN, create, i$, x$, ref$, len$, e;
    isNaN = core.Number.isNaN;
    create = core.Object.create;
    ok(toString$.call(isNaN).slice(8, -1) === 'Function', 'Is function');
    ok(isNaN(NaN), 'Number.isNaN NaN');
    for (i$ = 0, len$ = (ref$ = [1, 0.1, -1, Math.pow(2, 16), Math.pow(2, 16) - 1, Math.pow(2, 31), Math.pow(2, 31) - 1, Math.pow(2, 32), Math.pow(2, 32) - 1, -0, Infinity, 'NaN', '5', false, new Number(NaN), new Number(Infinity), new Number(5), new Number(0.1), void 8, null, {}, fn$, create(null)]).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(!isNaN(x$), "not Number.isNaN " + typeof x$ + " " + (fn1$()));
    }
    function fn$(){}
    function fn1$(){
      try {
        return String(x$);
      } catch (e$) {
        e = e$;
        return 'Object.create(null)';
      }
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('Number.isSafeInteger', function(){
    var isSafeInteger, create, i$, x$, ref$, len$, y$, e;
    isSafeInteger = core.Number.isSafeInteger;
    create = core.Object.create;
    ok(toString$.call(isSafeInteger).slice(8, -1) === 'Function', 'Is function');
    for (i$ = 0, len$ = (ref$ = [1, -1, Math.pow(2, 16), Math.pow(2, 16) - 1, Math.pow(2, 31), Math.pow(2, 31) - 1, Math.pow(2, 32), Math.pow(2, 32) - 1, -0, 9007199254740991, -9007199254740991]).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(isSafeInteger(x$), "isSafeInteger " + typeof x$ + " " + x$);
    }
    for (i$ = 0, len$ = (ref$ = [9007199254740992, -9007199254740992, NaN, 0.1, Infinity, 'NaN', '5', false, new Number(NaN), new Number(Infinity), new Number(5), new Number(0.1), void 8, null, {}, fn$, create(null)]).length; i$ < len$; ++i$) {
      y$ = ref$[i$];
      ok(!isSafeInteger(y$), "not isSafeInteger " + typeof y$ + " " + (fn1$()));
    }
    function fn$(){}
    function fn1$(){
      try {
        return String(y$);
      } catch (e$) {
        e = e$;
        return 'Object.create(null)';
      }
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  QUnit.module('ES6');
  test('Number.MAX_SAFE_INTEGER', function(){
    strictEqual(core.Number.MAX_SAFE_INTEGER, Math.pow(2, 53) - 1, 'Is 2^53 - 1');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  QUnit.module('ES6');
  test('Number.MIN_SAFE_INTEGER', function(){
    strictEqual(core.Number.MIN_SAFE_INTEGER, -Math.pow(2, 53) + 1, 'Is -2^53 + 1');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('Number.parseFloat', function(){
    ok(toString$.call(core.Number.parseFloat).slice(8, -1) === 'Function', 'Is function');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('Number.parseInt', function(){
    ok(toString$.call(core.Number.parseInt).slice(8, -1) === 'Function', 'Is function');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var descriptors, eq, deq, toString$ = {}.toString;
  QUnit.module('ES6');
  descriptors = function(){
    try {
      return 2 === core.Object.defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  deq = deepEqual;
  test('Object.assign', function(){
    var ref$, assign, defineProperty, foo, str, c, d, D, O;
    ref$ = core.Object, assign = ref$.assign, defineProperty = ref$.defineProperty;
    ok(toString$.call(assign).slice(8, -1) === 'Function', 'Is function');
    foo = {
      q: 1
    };
    eq(foo, assign(foo, {
      bar: 2
    }), 'assign return target');
    eq(foo.bar, 2, 'assign define properties');
    deq(assign({}, {
      q: 1
    }, {
      w: 2
    }), {
      q: 1,
      w: 2
    });
    deq(assign({}, 'qwe'), {
      0: 'q',
      1: 'w',
      2: 'e'
    });
    throws(function(){
      return assign(null, {
        q: 1
      });
    }, TypeError);
    throws(function(){
      return assign(void 8, {
        q: 1
      });
    }, TypeError);
    str = assign('qwe', {
      q: 1
    });
    eq(typeof str, 'object');
    eq(String(str), 'qwe');
    eq(str.q, 1);
    if (descriptors) {
      foo = {
        baz: 1
      };
      assign(foo, defineProperty({}, 'bar', {
        get: function(){
          return this.baz + 1;
        }
      }));
      ok(foo.bar === void 8, "assign don't copy descriptors");
      c = core.Symbol('c');
      d = core.Symbol('d');
      D = (ref$ = {
        a: 'a'
      }, ref$[c] = 'c', ref$);
      defineProperty(D, 'b', {
        value: 'b'
      });
      defineProperty(D, d, {
        value: 'd'
      });
      O = assign({}, D);
      eq(O.a, 'a', 'a');
      eq(O.b, void 8, 'b');
      eq(O[c], 'c', 'c');
      eq(O[d], void 8, 'd');
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('Object.is', function(){
    var same;
    same = core.Object.is;
    ok(toString$.call(same).slice(8, -1) === 'Function', 'Is function');
    ok(same(1, 1), '1 is 1');
    ok(same(NaN, NaN), '1 is 1');
    ok(!same(0, -0), '0 isnt -0');
    ok(!same({}, {}), '{} isnt {}');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  if (Object.setPrototypeOf || '__proto__' in Object.prototype) {
    QUnit.module('ES6');
    eq = strictEqual;
    test('Object.setPrototypeOf', function(){
      var setPrototypeOf, tmp;
      setPrototypeOf = core.Object.setPrototypeOf;
      ok(toString$.call(setPrototypeOf).slice(8, -1) === 'Function', 'Is function');
      ok('apply' in setPrototypeOf({}, Function.prototype), 'Parent properties in target');
      eq(setPrototypeOf({
        a: 2
      }, {
        b: function(){
          return Math.pow(this.a, 2);
        }
      }).b(), 4, 'Child and parent properties in target');
      eq(setPrototypeOf(tmp = {}, {
        a: 1
      }), tmp, 'setPrototypeOf return target');
      ok(!('toString' in setPrototypeOf({}, null)), 'Can set null as prototype');
    });
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Object static methods accept primitives', function(){
    var i$, ref$, len$, method, j$, ref1$, len1$, value;
    for (i$ = 0, len$ = (ref$ = ['freeze', 'seal', 'preventExtensions', 'getOwnPropertyDescriptor', 'getPrototypeOf', 'isExtensible', 'isSealed', 'isFrozen', 'keys', 'getOwnPropertyNames']).length; i$ < len$; ++i$) {
      method = ref$[i$];
      for (j$ = 0, len1$ = (ref1$ = [42, 'foo', false]).length; j$ < len1$; ++j$) {
        value = ref1$[j$];
        ok((fn$()), "Object." + method + " accept " + toString$.call(value).slice(8, -1));
      }
    }
    for (i$ = 0, len$ = (ref$ = ['freeze', 'seal', 'preventExtensions']).length; i$ < len$; ++i$) {
      method = ref$[i$];
      for (j$ = 0, len1$ = (ref1$ = [42, 'foo', false, null, void 8, {}]).length; j$ < len1$; ++j$) {
        value = ref1$[j$];
        eq(core.Object[method](value), value, "Object." + method + " returns target on " + toString$.call(value).slice(8, -1));
      }
    }
    for (i$ = 0, len$ = (ref$ = ['isSealed', 'isFrozen']).length; i$ < len$; ++i$) {
      method = ref$[i$];
      for (j$ = 0, len1$ = (ref1$ = [42, 'foo', false, null, void 8]).length; j$ < len1$; ++j$) {
        value = ref1$[j$];
        eq(core.Object[method](value), true, "Object." + method + " returns true on " + toString$.call(value).slice(8, -1));
      }
    }
    for (i$ = 0, len$ = (ref$ = [42, 'foo', false, null, void 8]).length; i$ < len$; ++i$) {
      value = ref$[i$];
      eq(core.Object.isExtensible(value), false, "Object.isExtensible returns false on " + toString$.call(value).slice(8, -1));
    }
    for (i$ = 0, len$ = (ref$ = ['getOwnPropertyDescriptor', 'getPrototypeOf', 'keys', 'getOwnPropertyNames']).length; i$ < len$; ++i$) {
      method = ref$[i$];
      for (j$ = 0, len1$ = (ref1$ = [null, void 8]).length; j$ < len1$; ++j$) {
        value = ref1$[j$];
        throws(fn1$, TypeError, "Object." + method + " throws on " + value);
      }
    }
    eq(core.Object.getPrototypeOf('foo'), String.prototype);
    function fn$(){
      try {
        core.Object[method](value);
        return true;
      } catch (e$) {}
    }
    function fn1$(){
      return core.Object[method](value);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, iterator, toString$ = {}.toString;
  QUnit.module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  iterator = core.Symbol.iterator;
  test('Promise', function(){
    ok(isFunction(core.Promise), 'Is function');
  });
  test('Promise#then', function(){
    ok(isFunction(core.Promise.prototype.then), 'Is function');
  });
  test('Promise#catch', function(){
    ok(isFunction(core.Promise.prototype['catch']), 'Is function');
  });
  test('Promise#@@toStringTag', function(){
    ok(core.Promise.prototype[core.Symbol.toStringTag] === 'Promise', 'Promise::@@toStringTag is `Promise`');
  });
  test('Promise.all', function(){
    var passed, iter, next, a, done;
    ok(isFunction(core.Promise.all), 'Is function');
    passed = false;
    iter = core.Array.values([1, 2, 3]);
    next = bind$(iter, 'next');
    iter.next = function(){
      passed = true;
      return next();
    };
    core.Promise.all(iter)['catch'](function(){});
    ok(passed, 'works with iterables');
    a = [];
    done = false;
    a['@@iterator'] = void 8;
    a[iterator] = function(){
      done = true;
      return core.getIteratorMethod([]).call(this);
    };
    core.Promise.all(a);
    ok(done);
  });
  test('Promise.race', function(){
    var passed, iter, next, a, done;
    ok(isFunction(core.Promise.race), 'Is function');
    passed = false;
    iter = core.Array.values([1, 2, 3]);
    next = bind$(iter, 'next');
    iter.next = function(){
      passed = true;
      return next();
    };
    core.Promise.race(iter)['catch'](function(){});
    ok(passed, 'works with iterables');
    a = [];
    done = false;
    a['@@iterator'] = void 8;
    a[iterator] = function(){
      done = true;
      return core.getIteratorMethod([]).call(this);
    };
    core.Promise.race(a);
    ok(done);
  });
  test('Promise.resolve', function(){
    ok(isFunction(core.Promise.resolve), 'Is function');
  });
  test('Promise.reject', function(){
    ok(isFunction(core.Promise.reject), 'Is function');
  });
  if (core.Object.setPrototypeOf) {
    test('Promise subclassing', function(it){
      var SubPromise, p1, p2, p3;
      SubPromise = function(x){
        var self;
        self = new core.Promise(x);
        core.Object.setPrototypeOf(self, SubPromise.prototype);
        self.mine = 'subclass';
        return self;
      };
      core.Object.setPrototypeOf(SubPromise, core.Promise);
      SubPromise.prototype = core.Object.create(core.Promise.prototype);
      SubPromise.prototype.constructor = SubPromise;
      p1 = SubPromise.resolve(5);
      strictEqual(p1.mine, 'subclass');
      p1 = p1.then(function(x){
        return strictEqual(x, 5);
      });
      strictEqual(p1.mine, 'subclass');
      p2 = new SubPromise(function(r){
        return r(6);
      });
      strictEqual(p2.mine, 'subclass');
      p2 = p2.then(function(x){
        return strictEqual(x, 6);
      });
      strictEqual(p2.mine, 'subclass');
      p3 = SubPromise.all([p1, p2]);
      strictEqual(p3.mine, 'subclass');
      ok(p3 instanceof core.Promise);
      ok(p3 instanceof SubPromise);
      p3.then(it.async(), function(e){
        return ok(false, e);
      });
    });
  }
  function bind$(obj, key, target){
    return function(){ return (target || obj)[key].apply(obj, arguments) };
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Reflect.apply', function(){
    var apply, C;
    apply = core.Reflect.apply;
    ok(toString$.call(apply).slice(8, -1) === 'Function', 'Reflect.apply is function');
    eq(apply.length, 3, 'arity is 3');
    if ('name' in apply) {
      eq(apply.name, 'apply', 'name is "apply"');
    }
    eq(apply(Array.prototype.push, [1, 2], [3, 4, 5]), 5);
    C = function(a, b, c){
      return a + b + c;
    };
    C.apply = 42;
    eq(apply(C, null, ['foo', 'bar', 'baz']), 'foobarbaz', 'works with redefined apply');
    throws(function(){
      return apply(42, null, []);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var getPrototypeOf, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  getPrototypeOf = core.Object.getPrototypeOf;
  eq = strictEqual;
  test('Reflect.construct', function(){
    var construct, C, inst, f, e;
    construct = core.Reflect.construct;
    ok(toString$.call(construct).slice(8, -1) === 'Function', 'Reflect.construct is function');
    eq(construct.length, 2, 'arity is 2');
    if ('name' in construct) {
      eq(construct.name, 'construct', 'name is "construct"');
    }
    C = function(a, b, c){
      return this.qux = a + b + c;
    };
    eq(construct(C, ['foo', 'bar', 'baz']).qux, 'foobarbaz', 'basic');
    C.apply = 42;
    eq(construct(C, ['foo', 'bar', 'baz']).qux, 'foobarbaz', 'works with redefined apply');
    inst = construct(function(){
      return this.x = 42;
    }, [], Array);
    eq(inst.x, 42, 'constructor with newTarget');
    ok(inst instanceof Array, 'prototype with newTarget');
    throws(function(){
      return construct(42, []);
    }, TypeError, 'throws on primitive');
    f = function(){};
    f.prototype = 42;
    ok((function(){
      try {
        return getPrototypeOf(construct(f, [])) === Object.prototype;
      } catch (e$) {
        e = e$;
        return false;
      }
    }()));
    eq(construct(core.Set, [[1, 2, 3, 2, 1]]).size, 3, 'works with native constructors');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var ref$, defineProperty, getOwnPropertyDescriptor, MODERN, eq, deq, toString$ = {}.toString;
  QUnit.module('ES6');
  ref$ = core.Object, defineProperty = ref$.defineProperty, getOwnPropertyDescriptor = ref$.getOwnPropertyDescriptor;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  deq = deepEqual;
  test('Reflect.defineProperty', function(){
    var defineProperty, O;
    defineProperty = core.Reflect.defineProperty;
    ok(toString$.call(defineProperty).slice(8, -1) === 'Function', 'Reflect.defineProperty is function');
    eq(defineProperty.length, 3, 'arity is 3');
    if ('name' in defineProperty) {
      eq(defineProperty.name, 'defineProperty', 'name is "defineProperty"');
    }
    O = {};
    eq(defineProperty(O, 'foo', {
      value: 123
    }), true);
    eq(O.foo, 123);
    if (MODERN) {
      O = {};
      defineProperty(O, 'foo', {
        value: 123,
        enumerable: true
      });
      deq(getOwnPropertyDescriptor(O, 'foo'), {
        value: 123,
        enumerable: true,
        configurable: false,
        writable: false
      });
      eq(defineProperty(O, 'foo', {
        value: 42
      }), false);
    }
    throws(function(){
      return defineProperty(42, 'foo', {
        value: 42
      });
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var defineProperty, MODERN, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  defineProperty = core.Object.defineProperty;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  test('Reflect.deleteProperty', function(){
    var deleteProperty, O;
    deleteProperty = core.Reflect.deleteProperty;
    ok(toString$.call(deleteProperty).slice(8, -1) === 'Function', 'Reflect.deleteProperty is function');
    eq(deleteProperty.length, 2, 'arity is 2');
    if ('name' in deleteProperty) {
      eq(deleteProperty.name, 'deleteProperty', 'name is "deleteProperty"');
    }
    O = {
      bar: 456
    };
    eq(deleteProperty(O, 'bar'), true);
    ok(!in$('bar', O));
    if (MODERN) {
      eq(deleteProperty(defineProperty({}, 'foo', {
        value: 42
      }), 'foo'), false);
    }
    throws(function(){
      return deleteProperty(42, 'foo');
    }, TypeError, 'throws on primitive');
  });
  function in$(x, xs){
    var i = -1, l = xs.length >>> 0;
    while (++i < l) if (x === xs[i]) return true;
    return false;
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var defineProperty, from, MODERN, eq, deq, toString$ = {}.toString;
  QUnit.module('ES6');
  defineProperty = core.Object.defineProperty;
  from = core.Array.from;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  deq = deepEqual;
  test('Reflect.enumerate', function(){
    var enumerate, iterator, obj, i, ref$;
    enumerate = core.Reflect.enumerate;
    iterator = core.Symbol.iterator;
    ok(toString$.call(enumerate).slice(8, -1) === 'Function', 'Reflect.enumerate is function');
    eq(enumerate.length, 1, 'arity is 1');
    if ('name' in enumerate) {
      eq(enumerate.name, 'enumerate', 'name is "enumerate"');
    }
    obj = {
      foo: 1,
      bar: 2
    };
    i = enumerate(obj);
    ok(iterator in i, 'returns iterator');
    deq(from(i), ['foo', 'bar'], 'bisic');
    obj = {
      q: 1,
      w: 2,
      e: 3
    };
    i = enumerate(obj);
    delete obj.w;
    deq(from(i), ['q', 'e'], 'ignore holes');
    obj = (ref$ = clone$({
      q: 1,
      w: 2,
      e: 3
    }), ref$.a = 4, ref$.s = 5, ref$.d = 6, ref$);
    deq(from(enumerate(obj)).sort(), ['a', 'd', 'e', 'q', 's', 'w'], 'works with prototype');
    throws(function(){
      return enumerate(42);
    }, TypeError, 'throws on primitive');
  });
  function clone$(it){
    function fun(){} fun.prototype = it;
    return new fun;
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Reflect.getOwnPropertyDescriptor', function(){
    var getOwnPropertyDescriptor, obj, desc;
    getOwnPropertyDescriptor = core.Reflect.getOwnPropertyDescriptor;
    ok(toString$.call(getOwnPropertyDescriptor).slice(8, -1) === 'Function', 'Reflect.getOwnPropertyDescriptor is function');
    eq(getOwnPropertyDescriptor.length, 2, 'arity is 2');
    if ('name' in getOwnPropertyDescriptor) {
      eq(getOwnPropertyDescriptor.name, 'getOwnPropertyDescriptor', 'name is "getOwnPropertyDescriptor"');
    }
    obj = {
      baz: 789
    };
    desc = getOwnPropertyDescriptor(obj, 'baz');
    eq(desc.value, 789);
    throws(function(){
      return getOwnPropertyDescriptor(42, 'constructor');
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Reflect.getPrototypeOf', function(){
    var getPrototypeOf;
    getPrototypeOf = core.Reflect.getPrototypeOf;
    ok(toString$.call(getPrototypeOf).slice(8, -1) === 'Function', 'Reflect.getPrototypeOf is function');
    eq(getPrototypeOf.length, 1, 'arity is 1');
    if ('name' in getPrototypeOf) {
      eq(getPrototypeOf.name, 'getPrototypeOf', 'name is "getPrototypeOf"');
    }
    eq(getPrototypeOf([]), Array.prototype);
    throws(function(){
      return getPrototypeOf(42);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var ref$, defineProperty, create, MODERN, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  ref$ = core.Object, defineProperty = ref$.defineProperty, create = ref$.create;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  test('Reflect.get', function(){
    var get, target, receiver;
    get = core.Reflect.get;
    ok(toString$.call(get).slice(8, -1) === 'Function', 'Reflect.get is function');
    if ('name' in get) {
      eq(get.name, 'get', 'name is "get"');
    }
    eq(get({
      qux: 987
    }, 'qux'), 987);
    if (MODERN) {
      target = create(defineProperty({
        z: 3
      }, 'w', {
        get: function(){
          return this;
        }
      }), {
        x: {
          value: 1
        },
        y: {
          get: function(){
            return this;
          }
        }
      });
      receiver = {};
      eq(get(target, 'x', receiver), 1, 'get x');
      eq(get(target, 'y', receiver), receiver, 'get y');
      eq(get(target, 'z', receiver), 3, 'get z');
      eq(get(target, 'w', receiver), receiver, 'get w');
      eq(get(target, 'u', receiver), void 8, 'get u');
    }
    throws(function(){
      return get(42, 'constructor');
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Reflect.has', function(){
    var has, O;
    has = core.Reflect.has;
    ok(toString$.call(has).slice(8, -1) === 'Function', 'Reflect.has is function');
    eq(has.length, 2, 'arity is 2');
    if ('name' in has) {
      eq(has.name, 'has', 'name is "has"');
    }
    O = {
      qux: 987
    };
    eq(has(O, 'qux'), true);
    eq(has(O, 'qwe'), false);
    eq(has(O, 'toString'), true);
    throws(function(){
      return has(42, 'constructor');
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var ref$, defineProperty, preventExtensions, MODERN, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  ref$ = core.Object, defineProperty = ref$.defineProperty, preventExtensions = ref$.preventExtensions;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  test('Reflect.isExtensible', function(){
    var isExtensible;
    isExtensible = core.Reflect.isExtensible;
    ok(toString$.call(isExtensible).slice(8, -1) === 'Function', 'Reflect.isExtensible is function');
    eq(isExtensible.length, 1, 'arity is 1');
    if ('name' in isExtensible) {
      eq(isExtensible.name, 'isExtensible', 'name is "isExtensible"');
    }
    ok(isExtensible({}));
    if (MODERN) {
      ok(!isExtensible(preventExtensions({})));
    }
    throws(function(){
      return isExtensible(42);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var defineProperty, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  defineProperty = core.Object.defineProperty;
  eq = strictEqual;
  test('Reflect.ownKeys', function(){
    var ownKeys, sym, O1, keys, O2;
    ownKeys = core.Reflect.ownKeys;
    sym = core.Symbol('c');
    ok(toString$.call(ownKeys).slice(8, -1) === 'Function', 'Reflect.ownKeys is function');
    eq(ownKeys.length, 1, 'arity is 1');
    if ('name' in ownKeys) {
      eq(ownKeys.name, 'ownKeys', 'name is "ownKeys"');
    }
    O1 = {
      a: 1
    };
    defineProperty(O1, 'b', {
      value: 2
    });
    O1[sym] = 3;
    keys = ownKeys(O1);
    eq(keys.length, 3, 'ownKeys return all own keys');
    ok(in$('a', keys), 'ownKeys return all own keys: simple');
    ok(in$('b', keys), 'ownKeys return all own keys: hidden');
    eq(O1[keys[2]], 3, 'ownKeys return all own keys: symbol');
    O2 = clone$(O1);
    keys = ownKeys(O2);
    eq(keys.length, 0, 'ownKeys return only own keys');
    throws(function(){
      return ownKeys(42);
    }, TypeError, 'throws on primitive');
  });
  function in$(x, xs){
    var i = -1, l = xs.length >>> 0;
    while (++i < l) if (x === xs[i]) return true;
    return false;
  }
  function clone$(it){
    function fun(){} fun.prototype = it;
    return new fun;
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var ref$, defineProperty, isExtensible, MODERN, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  ref$ = core.Object, defineProperty = ref$.defineProperty, isExtensible = ref$.isExtensible;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  test('Reflect.preventExtensions', function(){
    var preventExtensions, obj;
    preventExtensions = core.Reflect.preventExtensions;
    ok(toString$.call(preventExtensions).slice(8, -1) === 'Function', 'Reflect.preventExtensions is function');
    eq(preventExtensions.length, 1, 'arity is 1');
    if ('name' in preventExtensions) {
      eq(preventExtensions.name, 'preventExtensions', 'name is "preventExtensions"');
    }
    obj = {};
    ok(preventExtensions(obj), true);
    if (MODERN) {
      ok(!isExtensible(obj));
    }
    throws(function(){
      return preventExtensions(42);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  if (Object.setPrototypeOf || '__proto__' in {}) {
    QUnit.module('ES6');
    eq = strictEqual;
    test('Reflect.setPrototypeOf', function(){
      var setPrototypeOf, obj, o;
      setPrototypeOf = core.Reflect.setPrototypeOf;
      ok(toString$.call(setPrototypeOf).slice(8, -1) === 'Function', 'Reflect.setPrototypeOf is function');
      if ('name' in setPrototypeOf) {
        eq(setPrototypeOf.name, 'setPrototypeOf', 'name is "setPrototypeOf"');
      }
      obj = {};
      ok(setPrototypeOf(obj, Array.prototype), true);
      ok(obj instanceof Array);
      throws(function(){
        return setPrototypeOf({}, 42);
      }, TypeError);
      throws(function(){
        return setPrototypeOf(42, {});
      }, TypeError, 'throws on primitive');
      ok(setPrototypeOf(o = {}, o) === false, 'false on recursive __proto__');
    });
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var ref$, defineProperty, getOwnPropertyDescriptor, create, MODERN, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  ref$ = core.Object, defineProperty = ref$.defineProperty, getOwnPropertyDescriptor = ref$.getOwnPropertyDescriptor, create = ref$.create;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  test('Reflect.set', function(){
    var set, obj, target, receiver, out;
    set = core.Reflect.set;
    ok(toString$.call(set).slice(8, -1) === 'Function', 'Reflect.set is function');
    if ('name' in set) {
      eq(set.name, 'set', 'name is "set"');
    }
    obj = {};
    ok(set(obj, 'quux', 654), true);
    eq(obj.quux, 654);
    target = {};
    receiver = {};
    set(target, 'foo', 1, receiver);
    eq(target.foo, void 8, 'target.foo === undefined');
    eq(receiver.foo, 1, 'receiver.foo === 1');
    if (MODERN) {
      defineProperty(receiver, 'bar', {
        value: 0,
        writable: true,
        enumerable: false,
        configurable: true
      });
      set(target, 'bar', 1, receiver);
      eq(receiver.bar, 1, 'receiver.bar === 1');
      eq(getOwnPropertyDescriptor(receiver, 'bar').enumerable, false, 'enumerability not overridden');
      target = create(defineProperty({
        z: 3
      }, 'w', {
        set: function(v){
          return out = this;
        }
      }), {
        x: {
          value: 1,
          writable: true,
          configurable: true
        },
        y: {
          set: function(v){
            out = this;
          }
        },
        c: {
          value: 1,
          writable: false,
          configurable: false
        }
      });
      eq(set(target, 'x', 2, target), true, 'set x');
      eq(target.x, 2, 'set x');
      out = null;
      eq(set(target, 'y', 2, target), true, 'set y');
      eq(out, target, 'set y');
      eq(set(target, 'z', 4, target), true);
      eq(target.z, 4, 'set z');
      out = null;
      eq(set(target, 'w', 1, target), true, 'set w');
      eq(out, target, 'set w');
      eq(set(target, 'u', 0, target), true, 'set u');
      eq(target.u, 0, 'set u');
      eq(set(target, 'c', 2, target), false, 'set c');
      eq(target.c, 1, 'set c');
    }
    throws(function(){
      return set(42, 'q', 42);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, isIterator, same, Set, Symbol, ref$, getOwnPropertyDescriptor, freeze, values, from, iterator, eq, deq, toString$ = {}.toString;
  QUnit.module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isIterator = function(it){
    return typeof it === 'object' && isFunction(it.next);
  };
  same = function(a, b){
    if (a === b) {
      return a !== 0 || 1 / a === 1 / b;
    } else {
      return a != a && b != b;
    }
  };
  Set = core.Set, Symbol = core.Symbol;
  ref$ = core.Object, getOwnPropertyDescriptor = ref$.getOwnPropertyDescriptor, freeze = ref$.freeze;
  ref$ = core.Array, values = ref$.values, from = ref$.from;
  iterator = core.Symbol.iterator;
  eq = strictEqual;
  deq = deepEqual;
  test('Set', function(){
    var S, r, done, iter, _add, a;
    ok(isFunction(Set), 'Is function');
    ok('add' in Set.prototype, 'add in Set.prototype');
    ok('clear' in Set.prototype, 'clear in Set.prototype');
    ok('delete' in Set.prototype, 'delete in Set.prototype');
    ok('forEach' in Set.prototype, 'forEach in Set.prototype');
    ok('has' in Set.prototype, 'has in Set.prototype');
    ok(new Set instanceof Set, 'new Set instanceof Set');
    eq(new Set(values([1, 2, 3, 2, 1])).size, 3, 'Init from iterator #1');
    eq(new Set([1, 2, 3, 2, 1]).size, 3, 'Init Set from iterator #2');
    eq(new Set([freeze({}), 1]).size, 2, 'Support frozen objects');
    S = new Set([1, 2, 3, 2, 1]);
    eq(S.size, 3);
    r = [];
    S.forEach(function(v){
      return r.push(v);
    });
    deq(r, [1, 2, 3]);
    eq(new Set([NaN, NaN, NaN]).size, 1);
    deq(from(new Set([3, 4]).add(2).add(1)), [3, 4, 2, 1]);
    done = false;
    iter = values([null, 1, 2]);
    iter['return'] = function(){
      return done = true;
    };
    _add = Set.prototype.add;
    Set.prototype.add = function(){
      throw 42;
    };
    try {
      new Set(iter);
    } catch (e$) {}
    Set.prototype.add = _add;
    ok(done, '.return #throw');
    a = [];
    done = false;
    a['@@iterator'] = void 8;
    a[iterator] = function(){
      done = true;
      return core.getIteratorMethod([]).call(this);
    };
    new Set(a);
    ok(done);
  });
  test('Set#add', function(){
    var a, S, chain, f;
    ok(isFunction(Set.prototype.add), 'Is function');
    a = [];
    S = new Set([NaN, 2, 3, 2, 1, a]);
    eq(S.size, 5);
    chain = S.add(NaN);
    eq(chain, S);
    eq(S.size, 5);
    S.add(2);
    eq(S.size, 5);
    S.add(a);
    eq(S.size, 5);
    S.add([]);
    eq(S.size, 6);
    S.add(4);
    eq(S.size, 7);
    S = new Set().add(freeze(f = {}));
    ok(S.has(f));
  });
  test('Set#clear', function(){
    var S, f;
    ok(isFunction(Set.prototype.clear), 'Is function');
    S = new Set;
    S.clear();
    eq(S.size, 0);
    S = new Set([1, 2, 3, 2, 1]);
    S.clear();
    eq(S.size, 0);
    ok(!S.has(1));
    ok(!S.has(2));
    ok(!S.has(3));
    S = new Set([1, f = freeze({})]);
    S.clear();
    eq(S.size, 0, 'Support frozen objects');
    ok(!S.has(1));
    ok(!S.has(f));
  });
  test('Set#delete', function(){
    var a, S, f;
    ok(isFunction(Set.prototype['delete']), 'Is function');
    a = [];
    S = new Set([NaN, 2, 3, 2, 1, a]);
    eq(S.size, 5);
    eq(S['delete'](NaN), true);
    eq(S.size, 4);
    eq(S['delete'](4), false);
    eq(S.size, 4);
    S['delete']([]);
    eq(S.size, 4);
    S['delete'](a);
    eq(S.size, 3);
    S.add(freeze(f = {}));
    eq(S.size, 4);
    S['delete'](f);
    eq(S.size, 3);
  });
  test('Set#forEach', function(){
    var r, count, S, set, s;
    ok(isFunction(Set.prototype.forEach), 'Is function');
    r = [];
    count = 0;
    S = new Set([1, 2, 3, 2, 1]);
    S.forEach(function(value){
      count++;
      r.push(value);
    });
    eq(count, 3);
    deq(r, [1, 2, 3]);
    set = new Set(['0', '1', '2', '3']);
    s = "";
    set.forEach(function(it){
      s += it;
      if (it === '2') {
        set['delete']('2');
        set['delete']('3');
        set['delete']('1');
        return set.add('4');
      }
    });
    eq(s, '0124');
    set = new Set(['0']);
    s = "";
    set.forEach(function(it){
      set['delete']('0');
      if (s !== '') {
        throw '!!!';
      }
      return s += it;
    });
    eq(s, '0');
  });
  test('Set#has', function(){
    var a, f, S;
    ok(isFunction(Set.prototype.has), 'Is function');
    a = [];
    f = freeze({});
    S = new Set([NaN, 2, 3, 2, 1, f, a]);
    ok(S.has(NaN));
    ok(S.has(a));
    ok(S.has(f));
    ok(S.has(2));
    ok(!S.has(4));
    ok(!S.has([]));
  });
  test('Set#size', function(){
    var size, sizeDesc;
    size = new Set([1]).size;
    eq(typeof size, 'number', 'size is number');
    eq(size, 1, 'size is correct');
    if (function(){
      try {
        return 2 === core.Object.defineProperty({}, 'a', {
          get: function(){
            return 2;
          }
        }).a;
      } catch (e$) {}
    }()) {
      sizeDesc = getOwnPropertyDescriptor(Set.prototype, 'size');
      ok(sizeDesc && sizeDesc.get, 'size is getter');
      ok(sizeDesc && !sizeDesc.set, 'size isnt setter');
      throws(function(){
        return Set.prototype.size;
      }, TypeError);
    }
  });
  test('Set & -0', function(){
    var set;
    set = new Set;
    set.add(-0);
    eq(set.size, 1);
    ok(set.has(0));
    ok(set.has(-0));
    set.forEach(function(it){
      return ok(!same(it, -0));
    });
    set['delete'](-0);
    eq(set.size, 0);
    set = new Set([-0]);
    set.forEach(function(key){
      return ok(!same(key, -0));
    });
  });
  test('Set#@@toStringTag', function(){
    eq(Set.prototype[Symbol != null ? Symbol.toStringTag : void 8], 'Set', 'Set::@@toStringTag is `Set`');
  });
  test('Set Iterator', function(){
    var set, keys, iterator;
    set = new Set(['a', 'b', 'c', 'd']);
    keys = [];
    iterator = set.keys();
    keys.push(iterator.next().value);
    ok(set['delete']('a'));
    ok(set['delete']('b'));
    ok(set['delete']('c'));
    set.add('e');
    keys.push(iterator.next().value);
    keys.push(iterator.next().value);
    ok(iterator.next().done);
    set.add('f');
    ok(iterator.next().done);
    deq(keys, ['a', 'd', 'e']);
  });
  test('Set#keys', function(){
    var iter;
    ok(typeof Set.prototype.keys === 'function', 'Is function');
    iter = new Set(['q', 'w', 'e']).keys();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Set Iterator');
    deq(iter.next(), {
      value: 'q',
      done: false
    });
    deq(iter.next(), {
      value: 'w',
      done: false
    });
    deq(iter.next(), {
      value: 'e',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Set#values', function(){
    var iter;
    ok(typeof Set.prototype.values === 'function', 'Is function');
    iter = new Set(['q', 'w', 'e']).values();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Set Iterator');
    deq(iter.next(), {
      value: 'q',
      done: false
    });
    deq(iter.next(), {
      value: 'w',
      done: false
    });
    deq(iter.next(), {
      value: 'e',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Set#entries', function(){
    var iter;
    ok(typeof Set.prototype.entries === 'function', 'Is function');
    iter = new Set(['q', 'w', 'e']).entries();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Set Iterator');
    deq(iter.next(), {
      value: ['q', 'q'],
      done: false
    });
    deq(iter.next(), {
      value: ['w', 'w'],
      done: false
    });
    deq(iter.next(), {
      value: ['e', 'e'],
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Set#@@iterator', function(){
    var iter;
    iter = core.getIterator(new Set(['q', 'w', 'e']));
    ok(isIterator(iter), 'Return iterator');
    eq(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Set Iterator');
    deq(iter.next(), {
      value: 'q',
      done: false
    });
    deq(iter.next(), {
      value: 'w',
      done: false
    });
    deq(iter.next(), {
      value: 'e',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String#codePointAt', function(){
    var codePointAt;
    codePointAt = core.String.codePointAt;
    ok(toString$.call(codePointAt).slice(8, -1) === 'Function', 'Is function');
    eq(codePointAt('abc\uD834\uDF06def', ''), 0x61);
    eq(codePointAt('abc\uD834\uDF06def', '_'), 0x61);
    eq(codePointAt('abc\uD834\uDF06def'), 0x61);
    eq(codePointAt('abc\uD834\uDF06def', -Infinity), void 8);
    eq(codePointAt('abc\uD834\uDF06def', -1), void 8);
    eq(codePointAt('abc\uD834\uDF06def', -0), 0x61);
    eq(codePointAt('abc\uD834\uDF06def', 0), 0x61);
    eq(codePointAt('abc\uD834\uDF06def', 3), 0x1D306);
    eq(codePointAt('abc\uD834\uDF06def', 4), 0xDF06);
    eq(codePointAt('abc\uD834\uDF06def', 5), 0x64);
    eq(codePointAt('abc\uD834\uDF06def', 42), void 8);
    eq(codePointAt('abc\uD834\uDF06def', Infinity), void 8);
    eq(codePointAt('abc\uD834\uDF06def', Infinity), void 8);
    eq(codePointAt('abc\uD834\uDF06def', NaN), 0x61);
    eq(codePointAt('abc\uD834\uDF06def', false), 0x61);
    eq(codePointAt('abc\uD834\uDF06def', null), 0x61);
    eq(codePointAt('abc\uD834\uDF06def', void 8), 0x61);
    eq(codePointAt('\uD834\uDF06def', ''), 0x1D306);
    eq(codePointAt('\uD834\uDF06def', '1'), 0xDF06);
    eq(codePointAt('\uD834\uDF06def', '_'), 0x1D306);
    eq(codePointAt('\uD834\uDF06def'), 0x1D306);
    eq(codePointAt('\uD834\uDF06def', -1), void 8);
    eq(codePointAt('\uD834\uDF06def', -0), 0x1D306);
    eq(codePointAt('\uD834\uDF06def', 0), 0x1D306);
    eq(codePointAt('\uD834\uDF06def', 1), 0xDF06);
    eq(codePointAt('\uD834\uDF06def', 42), void 8);
    eq(codePointAt('\uD834\uDF06def', false), 0x1D306);
    eq(codePointAt('\uD834\uDF06def', null), 0x1D306);
    eq(codePointAt('\uD834\uDF06def', void 8), 0x1D306);
    eq(codePointAt('\uD834abc', ''), 0xD834);
    eq(codePointAt('\uD834abc', '_'), 0xD834);
    eq(codePointAt('\uD834abc'), 0xD834);
    eq(codePointAt('\uD834abc', -1), void 8);
    eq(codePointAt('\uD834abc', -0), 0xD834);
    eq(codePointAt('\uD834abc', 0), 0xD834);
    eq(codePointAt('\uD834abc', false), 0xD834);
    eq(codePointAt('\uD834abc', NaN), 0xD834);
    eq(codePointAt('\uD834abc', null), 0xD834);
    eq(codePointAt('\uD834abc', void 8), 0xD834);
    eq(codePointAt('\uDF06abc', ''), 0xDF06);
    eq(codePointAt('\uDF06abc', '_'), 0xDF06);
    eq(codePointAt('\uDF06abc'), 0xDF06);
    eq(codePointAt('\uDF06abc', -1), void 8);
    eq(codePointAt('\uDF06abc', -0), 0xDF06);
    eq(codePointAt('\uDF06abc', 0), 0xDF06);
    eq(codePointAt('\uDF06abc', false), 0xDF06);
    eq(codePointAt('\uDF06abc', NaN), 0xDF06);
    eq(codePointAt('\uDF06abc', null), 0xDF06);
    eq(codePointAt('\uDF06abc', void 8), 0xDF06);
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return codePointAt(null, 0);
      }, TypeError);
      throws(function(){
        return codePointAt(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('String#endsWith', function(){
    var endsWith;
    endsWith = core.String.endsWith;
    ok(toString$.call(endsWith).slice(8, -1) === 'Function', 'Is function');
    ok(endsWith('undefined'));
    ok(!endsWith('undefined', null));
    ok(endsWith('abc', ''));
    ok(endsWith('abc', 'c'));
    ok(endsWith('abc', 'bc'));
    ok(!endsWith('abc', 'ab'));
    ok(endsWith('abc', '', NaN));
    ok(!endsWith('abc', 'c', -1));
    ok(endsWith('abc', 'a', 1));
    ok(endsWith('abc', 'c', Infinity));
    ok(endsWith('abc', 'a', true));
    ok(!endsWith('abc', 'c', 'x'));
    ok(!endsWith('abc', 'a', 'x'));
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return endsWith(null, '.');
      }, TypeError);
      throws(function(){
        return endsWith(void 8, '.');
      }, TypeError);
    }
    throws(function(){
      return endsWith('qwe', /./);
    }, TypeError);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String.fromCodePoint', function(){
    var fromCodePoint, tmp, counter, result;
    fromCodePoint = core.String.fromCodePoint;
    ok(toString$.call(fromCodePoint).slice(8, -1) === 'Function', 'Is function');
    eq(fromCodePoint.length, 1, 'length is 1');
    if ('name' in fromCodePoint) {
      eq(fromCodePoint.name, 'fromCodePoint', 'name is "fromCodePoint"');
    }
    eq(fromCodePoint(''), '\0');
    eq(fromCodePoint(), '');
    eq(fromCodePoint(-0), '\0');
    eq(fromCodePoint(0), '\0');
    eq(fromCodePoint(0x1D306), '\uD834\uDF06');
    eq(fromCodePoint(0x1D306, 0x61, 0x1D307), '\uD834\uDF06a\uD834\uDF07');
    eq(fromCodePoint(0x61, 0x62, 0x1D307), 'ab\uD834\uDF07');
    eq(fromCodePoint(false), '\0');
    eq(fromCodePoint(null), '\0');
    throws(function(){
      return fromCodePoint('_');
    }, RangeError);
    throws(function(){
      return fromCodePoint('+Infinity');
    }, RangeError);
    throws(function(){
      return fromCodePoint('-Infinity');
    }, RangeError);
    throws(function(){
      return fromCodePoint(-1);
    }, RangeError);
    throws(function(){
      return fromCodePoint(0x10FFFF + 1);
    }, RangeError);
    throws(function(){
      return fromCodePoint(3.14);
    }, RangeError);
    throws(function(){
      return fromCodePoint(3e-2);
    }, RangeError);
    throws(function(){
      return fromCodePoint(-Infinity);
    }, RangeError);
    throws(function(){
      return fromCodePoint(Infinity);
    }, RangeError);
    throws(function(){
      return fromCodePoint(NaN);
    }, RangeError);
    throws(function(){
      return fromCodePoint(void 8);
    }, RangeError);
    throws(function(){
      return fromCodePoint({});
    }, RangeError);
    throws(function(){
      return fromCodePoint(/./);
    }, RangeError);
    tmp = 0x60;
    eq(fromCodePoint({
      valueOf: function(){
        return ++tmp;
      }
    }), 'a');
    eq(tmp, 0x61);
    counter = Math.pow(2, 15) * 3 / 2;
    result = [];
    while (--counter >= 0) {
      result.push(0);
    }
    fromCodePoint.apply(null, result);
    counter = Math.pow(2, 15) * 3 / 2;
    result = [];
    while (--counter >= 0) {
      result.push(0xFFFF + 1);
    }
    fromCodePoint.apply(null, result);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('String#includes', function(){
    var includes;
    includes = core.String.includes;
    ok(toString$.call(includes).slice(8, -1) === 'Function', 'Is function');
    ok(!includes('abc'));
    ok(includes('aundefinedb'));
    ok(includes('abcd', 'b', 1));
    ok(!includes('abcd', 'b', 2));
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return includes(null, '.');
      }, TypeError);
      throws(function(){
        return includes(void 8, '.');
      }, TypeError);
    }
    throws(function(){
      return includes('foo[a-z]+(bar)?', /[a-z]+/);
    }, TypeError);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, deq, isFunction, isIterator, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  deq = deepEqual;
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isIterator = function(it){
    return typeof it === 'object' && isFunction(it.next);
  };
  test('String#@@iterator', function(){
    var iter, ref$;
    iter = core.getIterator('qwe');
    eq(iter[(ref$ = core.Symbol) != null ? ref$.toStringTag : void 8], 'String Iterator');
    deq(iter.next(), {
      value: 'q',
      done: false
    });
    deq(iter.next(), {
      value: 'w',
      done: false
    });
    deq(iter.next(), {
      value: 'e',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
    eq(core.Array.from('𠮷𠮷𠮷').length, 3);
    iter = core.getIterator('𠮷𠮷𠮷');
    deq(iter.next(), {
      value: '𠮷',
      done: false
    });
    deq(iter.next(), {
      value: '𠮷',
      done: false
    });
    deq(iter.next(), {
      value: '𠮷',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String.raw', function(){
    var raw;
    raw = core.String.raw;
    ok(toString$.call(raw).slice(8, -1) === 'Function', 'Is function');
    eq(raw.length, 1, 'arity is 1');
    if ('name' in raw) {
      eq(raw.name, 'raw', 'name is "raw"');
    }
    eq(raw({
      raw: ['Hi\\n', '!']
    }, 'Bob'), 'Hi\\nBob!', 'raw is array');
    eq(raw({
      raw: 'test'
    }, 0, 1, 2), 't0e1s2t', 'raw is string');
    eq(raw({
      raw: 'test'
    }, 0), 't0est', 'lacks substituting');
    throws(function(){
      return raw({});
    }, TypeError);
    throws(function(){
      return raw({
        raw: null
      });
    }, TypeError);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String#repeat', function(){
    var repeat;
    repeat = core.String.repeat;
    ok(toString$.call(repeat).slice(8, -1) === 'Function', 'Is function');
    eq(repeat('qwe', 3), 'qweqweqwe');
    eq(repeat('qwe', 2.5), 'qweqwe');
    throws(function(){
      return repeat('qwe', -1);
    }, RangeError);
    throws(function(){
      return repeat('qwe', Infinity);
    }, RangeError);
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return repeat(null, 1);
      }, TypeError);
      throws(function(){
        return repeat(void 8, 1);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('String#startsWith', function(){
    var startsWith;
    startsWith = core.String.startsWith;
    ok(toString$.call(startsWith).slice(8, -1) === 'Function', 'Is function');
    ok(startsWith('undefined'));
    ok(!startsWith('undefined', null));
    ok(startsWith('abc', ''));
    ok(startsWith('abc', 'a'));
    ok(startsWith('abc', 'ab'));
    ok(!startsWith('abc', 'bc'));
    ok(startsWith('abc', '', NaN));
    ok(startsWith('abc', 'a', -1));
    ok(!startsWith('abc', 'a', 1));
    ok(!startsWith('abc', 'a', Infinity));
    ok(startsWith('abc', 'b', true));
    ok(startsWith('abc', 'a', 'x'));
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return startsWith(null, '.');
      }, TypeError);
      throws(function(){
        return startsWith(void 8, '.');
      }, TypeError);
    }
    throws(function(){
      return startsWith('qwe', /./);
    }, TypeError);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String#trim', function(){
    var trim;
    trim = core.String.trim;
    ok(toString$.call(trim).slice(8, -1) === 'Function', 'Is function');
    eq(trim(' \n  q w e \n  '), 'q w e', 'removes whitespaces at left & right side of string');
    eq(trim('\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u180E\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF'), '', 'removes all whitespaces');
    eq(trim('\u200b\u0085'), '\u200b\u0085', "shouldn't remove this symbols");
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return trim(null, 0);
      }, TypeError);
      throws(function(){
        return trim(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, deq, Symbol, ref$, defineProperty, getOwnPropertyDescriptor, create, isFunction, isNative, descriptors, G, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  deq = deepEqual;
  Symbol = core.Symbol;
  ref$ = core.Object, defineProperty = ref$.defineProperty, getOwnPropertyDescriptor = ref$.getOwnPropertyDescriptor, create = ref$.create;
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isNative = function(it){
    return /\[native code\]\s*\}\s*$/.test(it);
  };
  descriptors = function(){
    try {
      return 2 === core.Object.defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  G = (typeof global != 'undefined' && global !== null) && global || window;
  test('Symbol', function(){
    var s1, s2, O, count, i;
    ok(isFunction(Symbol), 'Is function');
    s1 = Symbol('foo');
    s2 = Symbol('foo');
    ok(s1 !== s2, 'Symbol("foo") !== Symbol("foo")');
    O = {};
    O[s1] = 42;
    ok(O[s1] === 42, 'Symbol() work as key');
    ok(O[s2] !== 42, 'Various symbols from one description are various keys');
    if (descriptors) {
      count = 0;
      for (i in O) {
        count++;
      }
      ok(count === 0, 'object[Symbol()] is not enumerable');
    }
  });
  test('Well-known Symbols', function(){
    var i$, x$, ref$, len$;
    for (i$ = 0, len$ = (ref$ = ['hasInstance', 'isConcatSpreadable', 'iterator', 'match', 'replace', 'search', 'species', 'split', 'toPrimitive', 'toStringTag', 'unscopables']).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(x$ in Symbol, "Symbol." + x$ + " available");
      ok(Object(Symbol[x$]) instanceof Symbol, "Symbol." + x$ + " is symbol");
    }
  });
  test('Global symbol registry', function(){
    var symbol;
    ok(isFunction(Symbol['for']), 'Symbol.for is function');
    ok(isFunction(Symbol.keyFor), 'Symbol.keyFor is function');
    symbol = Symbol['for']('foo');
    eq(Symbol['for']('foo'), symbol);
    eq(Symbol.keyFor(symbol), 'foo');
  });
  test('Symbol#@@toStringTag', function(){
    ok(Symbol.prototype[Symbol.toStringTag] === 'Symbol', 'Symbol::@@toStringTag is `Symbol`');
  });
  test('Object.getOwnPropertySymbols', function(){
    var ref$, getOwnPropertySymbols, getOwnPropertyNames, obj, foo;
    ref$ = core.Object, getOwnPropertySymbols = ref$.getOwnPropertySymbols, getOwnPropertyNames = ref$.getOwnPropertyNames;
    ok(isFunction(getOwnPropertySymbols), 'Is function');
    obj = {
      q: 1,
      w: 2,
      e: 3
    };
    obj[Symbol()] = 42;
    obj[Symbol()] = 43;
    deq(getOwnPropertyNames(obj).sort(), ['e', 'q', 'w']);
    eq(getOwnPropertySymbols(obj).length, 2);
    foo = (ref$ = clone$(obj), ref$.a = 1, ref$.s = 2, ref$.d = 3, ref$);
    foo[Symbol()] = 44;
    deq(getOwnPropertyNames(foo).sort(), ['a', 'd', 's']);
    eq(getOwnPropertySymbols(foo).length, 1);
  });
  if (typeof JSON != 'undefined' && JSON !== null) {
    test('Symbols & JSON.stringify', function(){
      var ref$;
      eq(JSON.stringify([1, Symbol('foo'), false, Symbol('bar'), {}]), '[1,null,false,null,{}]', 'array value');
      eq(JSON.stringify({
        foo: Symbol('foo')
      }), '{}', 'object value');
      if (descriptors) {
        eq(JSON.stringify((ref$ = {}, ref$[Symbol('foo')] = 1, ref$.bar = 2, ref$)), '{"bar":2}', 'object key');
      }
    });
  }
  if (descriptors) {
    test('Symbols & descriptors', function(){
      var ref$, create, defineProperty, getOwnPropertyDescriptor, keys, getOwnPropertyNames, getOwnPropertySymbols, d, e, f, i, j, proto, O, desc;
      ref$ = core.Object, create = ref$.create, defineProperty = ref$.defineProperty, getOwnPropertyDescriptor = ref$.getOwnPropertyDescriptor, keys = ref$.keys, getOwnPropertyNames = ref$.getOwnPropertyNames, getOwnPropertySymbols = ref$.getOwnPropertySymbols;
      d = Symbol('d');
      e = Symbol('e');
      f = Symbol('f');
      i = Symbol('i');
      j = Symbol('j');
      proto = (ref$ = {
        g: 'g'
      }, ref$[i] = 'i', ref$);
      defineProperty(proto, 'h', {
        value: 'h'
      });
      defineProperty(proto, 'j', {
        value: 'j'
      });
      O = create(proto);
      O.a = 'a';
      O[d] = 'd';
      defineProperty(O, 'b', {
        value: 'b'
      });
      defineProperty(O, 'c', {
        value: 'c',
        enumerable: true
      });
      defineProperty(O, e, {
        configurable: true,
        writable: true,
        value: 'e'
      });
      desc = {
        value: 'f',
        enumerable: true
      };
      defineProperty(O, f, desc);
      eq(desc.enumerable, true, 'defineProperty not changes descriptor object');
      deq(getOwnPropertyDescriptor(O, 'a'), {
        configurable: true,
        writable: true,
        enumerable: true,
        value: 'a'
      }, 'getOwnPropertyDescriptor a');
      deq(getOwnPropertyDescriptor(O, 'b'), {
        configurable: false,
        writable: false,
        enumerable: false,
        value: 'b'
      }, 'getOwnPropertyDescriptor b');
      deq(getOwnPropertyDescriptor(O, 'c'), {
        configurable: false,
        writable: false,
        enumerable: true,
        value: 'c'
      }, 'getOwnPropertyDescriptor c');
      deq(getOwnPropertyDescriptor(O, d), {
        configurable: true,
        writable: true,
        enumerable: true,
        value: 'd'
      }, 'getOwnPropertyDescriptor d');
      deq(getOwnPropertyDescriptor(O, e), {
        configurable: true,
        writable: true,
        enumerable: false,
        value: 'e'
      }, 'getOwnPropertyDescriptor e');
      deq(getOwnPropertyDescriptor(O, f), {
        configurable: false,
        writable: false,
        enumerable: true,
        value: 'f'
      }, 'getOwnPropertyDescriptor f');
      eq(getOwnPropertyDescriptor(O, 'g'), void 8, 'getOwnPropertyDescriptor g');
      eq(getOwnPropertyDescriptor(O, 'h'), void 8, 'getOwnPropertyDescriptor h');
      eq(getOwnPropertyDescriptor(O, i), void 8, 'getOwnPropertyDescriptor i');
      eq(getOwnPropertyDescriptor(O, j), void 8, 'getOwnPropertyDescriptor j');
      eq(getOwnPropertyDescriptor(O, 'k'), void 8, 'getOwnPropertyDescriptor k');
      eq(keys(O).length, 2, 'Object.keys');
      eq(getOwnPropertyNames(O).length, 3, 'Object.getOwnPropertyNames');
      eq(getOwnPropertySymbols(O).length, 3, 'Object.getOwnPropertySymbols');
      eq(core.Reflect.ownKeys(O).length, 6, 'Reflect.ownKeys');
      delete O[e];
      O[e] = 'e';
      deq(getOwnPropertyDescriptor(O, e), {
        configurable: true,
        writable: true,
        enumerable: true,
        value: 'e'
      }, 'redefined non-enum key');
    });
    test('Symbols & Object.defineProperties', function(){
      var ref$, defineProperty, defineProperties, c, d, D, O;
      ref$ = core.Object, defineProperty = ref$.defineProperty, defineProperties = ref$.defineProperties;
      c = core.Symbol('c');
      d = core.Symbol('d');
      D = (ref$ = {
        a: {
          value: 'a'
        }
      }, ref$[c] = {
        value: 'c'
      }, ref$);
      defineProperty(D, 'b', {
        value: {
          value: 'b'
        }
      });
      defineProperty(D, d, {
        value: {
          value: 'd'
        }
      });
      O = defineProperties({}, D);
      eq(O.a, 'a', 'a');
      eq(O.b, void 8, 'b');
      eq(O[c], 'c', 'c');
      eq(O[d], void 8, 'd');
    });
    test('Symbols & Object.create', function(){
      var ref$, defineProperty, create, c, d, D, O;
      ref$ = core.Object, defineProperty = ref$.defineProperty, create = ref$.create;
      c = core.Symbol('c');
      d = core.Symbol('d');
      D = (ref$ = {
        a: {
          value: 'a'
        }
      }, ref$[c] = {
        value: 'c'
      }, ref$);
      defineProperty(D, 'b', {
        value: {
          value: 'b'
        }
      });
      defineProperty(D, d, {
        value: {
          value: 'd'
        }
      });
      O = create(null, D);
      eq(O.a, 'a', 'a');
      eq(O.b, void 8, 'b');
      eq(O[c], 'c', 'c');
      eq(O[d], void 8, 'd');
    });
  }
  function clone$(it){
    function fun(){} fun.prototype = it;
    return new fun;
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, WeakMap, Map, freeze, values, iterator, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  WeakMap = core.WeakMap, Map = core.Map;
  freeze = core.Object.freeze;
  values = core.Array.values;
  iterator = core.Symbol.iterator;
  eq = strictEqual;
  test('WeakMap', function(){
    var a, b, f, M, done, iter;
    ok(isFunction(WeakMap), 'Is function');
    ok('delete' in WeakMap.prototype, 'delete in WeakMap.prototype');
    ok('get' in WeakMap.prototype, 'get in WeakMap.prototype');
    ok('has' in WeakMap.prototype, 'has in WeakMap.prototype');
    ok('set' in WeakMap.prototype, 'set in WeakMap.prototype');
    ok(new WeakMap instanceof WeakMap, 'new WeakMap instanceof WeakMap');
    eq(new WeakMap(values([[a = {}, b = {}]])).get(a), b, 'Init WeakMap from iterator #1');
    eq(new WeakMap(new Map([[a = {}, b = {}]])).get(a), b, 'Init WeakMap from iterator #2');
    eq(new WeakMap([[f = freeze({}), 42]]).get(f), 42, 'Support frozen objects');
    M = new WeakMap;
    M.set(freeze(f = {}), 42);
    eq(M.has(f), true, 'works with frozen objects, #1');
    eq(M.get(f), 42, 'works with frozen objects, #2');
    M['delete'](f);
    eq(M.has(f), false, 'works with frozen objects, #3');
    eq(M.get(f), void 8, 'works with frozen objects, #4');
    done = false;
    iter = values([null, 1, 2]);
    iter['return'] = function(){
      return done = true;
    };
    try {
      new WeakMap(iter);
    } catch (e$) {}
    ok(done, '.return #throw');
    ok(!('clear' in WeakMap.prototype), 'should not contains `.clear` method');
    a = [];
    done = false;
    a['@@iterator'] = void 8;
    a[iterator] = function(){
      done = true;
      return core.getIteratorMethod([]).call(this);
    };
    new WeakMap(a);
    ok(done);
  });
  test('WeakMap#delete', function(){
    var M, a, b;
    ok(isFunction(WeakMap.prototype['delete']), 'Is function');
    M = new WeakMap([[a = {}, 42], [b = {}, 21]]);
    ok(M.has(a) && M.has(b), 'WeakMap has values before .delete()');
    M['delete'](a);
    ok(!M.has(a) && M.has(b), 'WeakMap hasn`t value after .delete()');
  });
  test('WeakMap#get', function(){
    var M, a;
    ok(isFunction(WeakMap.prototype.get), 'Is function');
    M = new WeakMap();
    eq(M.get({}), void 8, 'WeakMap .get() before .set() return undefined');
    M.set(a = {}, 42);
    eq(M.get(a), 42, 'WeakMap .get() return value');
    M['delete'](a);
    eq(M.get(a), void 8, 'WeakMap .get() after .delete() return undefined');
  });
  test('WeakMap#has', function(){
    var M, a;
    ok(isFunction(WeakMap.prototype.has), 'Is function');
    M = new WeakMap();
    ok(!M.has({}), 'WeakMap .has() before .set() return false');
    M.set(a = {}, 42);
    ok(M.has(a), 'WeakMap .has() return true');
    M['delete'](a);
    ok(!M.has(a), 'WeakMap .has() after .delete() return false');
  });
  test('WeakMap#set', function(){
    var w, a, e;
    ok(isFunction(WeakMap.prototype.set), 'Is function');
    ok((w = new WeakMap).set(a = {}, 42) === w, 'chaining');
    ok((function(){
      try {
        new WeakMap().set(42, 42);
        return false;
      } catch (e$) {
        e = e$;
        return true;
      }
    }()), 'throws with primitive keys');
  });
  test('WeakMap#@@toStringTag', function(){
    var ref$;
    eq(WeakMap.prototype[(ref$ = core.Symbol) != null ? ref$.toStringTag : void 8], 'WeakMap', 'WeakMap::@@toStringTag is `WeakMap`');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, WeakSet, freeze, values, iterator, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  WeakSet = core.WeakSet;
  freeze = core.Object.freeze;
  values = core.Array.values;
  iterator = core.Symbol.iterator;
  eq = strictEqual;
  test('WeakSet', function(){
    var a, f, S, done, iter;
    ok(isFunction(WeakSet), 'Is function');
    ok('add' in WeakSet.prototype, 'add in WeakSet.prototype');
    ok('delete' in WeakSet.prototype, 'delete in WeakSet.prototype');
    ok('has' in WeakSet.prototype, 'has in WeakSet.prototype');
    ok(new WeakSet instanceof WeakSet, 'new WeakSet instanceof WeakSet');
    ok(new WeakSet(values([a = {}])).has(a), 'Init WeakSet from iterator #1');
    ok(new WeakSet([a = {}]).has(a), 'Init WeakSet from iterator #2');
    ok(new WeakSet([freeze(f = {})]).has(f), 'Support frozen objects');
    S = new WeakSet;
    S.add(freeze(f = {}));
    eq(S.has(f), true, 'works with frozen objects, #1');
    S['delete'](f);
    eq(S.has(f), false, 'works with frozen objects, #2');
    done = false;
    iter = values([null, 1, 2]);
    iter['return'] = function(){
      return done = true;
    };
    try {
      new WeakSet(iter);
    } catch (e$) {}
    ok(done, '.return #throw');
    ok(!('clear' in WeakSet.prototype), 'should not contains `.clear` method');
    a = [];
    done = false;
    a['@@iterator'] = void 8;
    a[iterator] = function(){
      done = true;
      return core.getIteratorMethod([]).call(this);
    };
    new WeakSet(a);
    ok(done);
  });
  test('WeakSet#add', function(){
    var w, e;
    ok(isFunction(WeakSet.prototype.add), 'Is function');
    ok((w = new WeakSet).add({}) === w, 'chaining');
    ok((function(){
      try {
        new WeakSet().add(42);
        return false;
      } catch (e$) {
        e = e$;
        return true;
      }
    }()), 'throws with primitive keys');
  });
  test('WeakSet#delete', function(){
    var S, a, b;
    ok(isFunction(WeakSet.prototype['delete']), 'Is function');
    S = new WeakSet().add(a = {}).add(b = {});
    ok(S.has(a) && S.has(b), 'WeakSet has values before .delete()');
    S['delete'](a);
    ok(!S.has(a) && S.has(b), 'WeakSet has`nt value after .delete()');
  });
  test('WeakSet#has', function(){
    var M, a;
    ok(isFunction(WeakSet.prototype.has), 'Is function');
    M = new WeakSet();
    ok(!M.has({}), 'WeakSet has`nt value');
    M.add(a = {});
    ok(M.has(a), 'WeakSet has value after .add()');
    M['delete'](a);
    ok(!M.has(a), 'WeakSet has`nt value after .delete()');
  });
  test('WeakSet::@@toStringTag', function(){
    var ref$;
    eq(WeakSet.prototype[(ref$ = core.Symbol) != null ? ref$.toStringTag : void 8], 'WeakSet', 'WeakSet::@@toStringTag is `WeakSet`');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var toString$ = {}.toString;
  QUnit.module('ES7');
  test('Array#includes', function(){
    var includes, arr, o;
    includes = core.Array.includes;
    ok(toString$.call(includes).slice(8, -1) === 'Function', 'Is function');
    arr = [1, 2, 3, -0, o = {}];
    ok(includes(arr, 1));
    ok(includes(arr, -0));
    ok(includes(arr, 0));
    ok(includes(arr, o));
    ok(!includes(arr, 4));
    ok(!includes(arr, -0.5));
    ok(!includes(arr, {}));
    ok(includes(Array(1), void 8));
    ok(includes([NaN], NaN));
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return includes(null, 0);
      }, TypeError);
      throws(function(){
        return includes(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, deq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  deq = deepEqual;
  test('Object.entries', function(){
    var ref$, entries, create, assign;
    ref$ = core.Object, entries = ref$.entries, create = ref$.create, assign = ref$.assign;
    ok(toString$.call(entries).slice(8, -1) === 'Function', 'Is function');
    eq(entries.length, 1, 'arity is 1');
    if ('name' in entries) {
      eq(entries.name, 'entries', 'name is "entries"');
    }
    deq(entries({
      q: 1,
      w: 2,
      e: 3
    }), [['q', 1], ['w', 2], ['e', 3]]);
    deq(entries(new String('qwe')), [['0', 'q'], ['1', 'w'], ['2', 'e']]);
    deq(entries(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    })), [['a', 4], ['s', 5], ['d', 6]]);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var descriptors, eq, create, toString$ = {}.toString;
  QUnit.module('ES7');
  descriptors = function(){
    try {
      return 2 === core.Object.defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  create = core.Object.create;
  test('Object.getOwnPropertyDescriptors', function(){
    var getOwnPropertyDescriptors, O, s, descs;
    getOwnPropertyDescriptors = core.Object.getOwnPropertyDescriptors;
    ok(toString$.call(getOwnPropertyDescriptors).slice(8, -1) === 'Function', 'Is function');
    O = create({
      q: 1
    }, {
      e: {
        value: 3
      }
    });
    O.w = 2;
    s = core.Symbol('s');
    O[s] = 4;
    descs = getOwnPropertyDescriptors(O);
    eq(descs.q, void 8);
    deepEqual(descs.w, {
      enumerable: true,
      configurable: true,
      writable: true,
      value: 2
    });
    if (descriptors) {
      deepEqual(descs.e, {
        enumerable: false,
        configurable: false,
        writable: false,
        value: 3
      });
    } else {
      deepEqual(descs.e, {
        enumerable: true,
        configurable: true,
        writable: true,
        value: 3
      });
    }
    eq(descs[s].value, 4);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, deq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  deq = deepEqual;
  test('Object.values', function(){
    var ref$, values, create, assign;
    ref$ = core.Object, values = ref$.values, create = ref$.create, assign = ref$.assign;
    ok(toString$.call(values).slice(8, -1) === 'Function', 'Is function');
    eq(values.length, 1, 'arity is 1');
    if ('name' in values) {
      eq(values.name, 'values', 'name is "values"');
    }
    deq(values({
      q: 1,
      w: 2,
      e: 3
    }), [1, 2, 3]);
    deq(values(new String('qwe')), ['q', 'w', 'e']);
    deq(values(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    })), [4, 5, 6]);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  test('RegExp.escape', function(){
    var escape;
    escape = core.RegExp.escape;
    ok(toString$.call(escape).slice(8, -1) === 'Function', 'Is function');
    eq(escape('qwe asd'), 'qwe asd', "Don't change simple string");
    eq(escape('\\[]{}()*+?.^$|'), '\\\\\\[\\]\\{\\}\\(\\)\\*\\+\\?\\.\\^\\$\\|', 'Escape all RegExp special chars');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  test('String#at', function(){
    var at;
    at = core.String.at;
    ok(toString$.call(at).slice(8, -1) === 'Function', 'Is function');
    eq(at('abc\uD834\uDF06def', -Infinity), '');
    eq(at('abc\uD834\uDF06def', -1), '');
    eq(at('abc\uD834\uDF06def', -0), 'a');
    eq(at('abc\uD834\uDF06def', +0), 'a');
    eq(at('abc\uD834\uDF06def', 1), 'b');
    eq(at('abc\uD834\uDF06def', 3), '\uD834\uDF06');
    eq(at('abc\uD834\uDF06def', 4), '\uDF06');
    eq(at('abc\uD834\uDF06def', 5), 'd');
    eq(at('abc\uD834\uDF06def', 42), '');
    eq(at('abc\uD834\uDF06def', Infinity), '');
    eq(at('abc\uD834\uDF06def', null), 'a');
    eq(at('abc\uD834\uDF06def', void 8), 'a');
    eq(at('abc\uD834\uDF06def'), 'a');
    eq(at('abc\uD834\uDF06def', false), 'a');
    eq(at('abc\uD834\uDF06def', NaN), 'a');
    eq(at('abc\uD834\uDF06def', ''), 'a');
    eq(at('abc\uD834\uDF06def', '_'), 'a');
    eq(at('abc\uD834\uDF06def', '1'), 'b');
    eq(at('abc\uD834\uDF06def', []), 'a');
    eq(at('abc\uD834\uDF06def', {}), 'a');
    eq(at('abc\uD834\uDF06def', -0.9), 'a');
    eq(at('abc\uD834\uDF06def', 1.9), 'b');
    eq(at('abc\uD834\uDF06def', 7.9), 'f');
    eq(at('abc\uD834\uDF06def', Math.pow(2, 32)), '');
    eq(at('\uD834\uDF06def', -Infinity), '');
    eq(at('\uD834\uDF06def', -1), '');
    eq(at('\uD834\uDF06def', -0), '\uD834\uDF06');
    eq(at('\uD834\uDF06def', 0), '\uD834\uDF06');
    eq(at('\uD834\uDF06def', 1), '\uDF06');
    eq(at('\uD834\uDF06def', 2), 'd');
    eq(at('\uD834\uDF06def', 3), 'e');
    eq(at('\uD834\uDF06def', 4), 'f');
    eq(at('\uD834\uDF06def', 42), '');
    eq(at('\uD834\uDF06def', Infinity), '');
    eq(at('\uD834\uDF06def', null), '\uD834\uDF06');
    eq(at('\uD834\uDF06def', void 8), '\uD834\uDF06');
    eq(at('\uD834\uDF06def'), '\uD834\uDF06');
    eq(at('\uD834\uDF06def', false), '\uD834\uDF06');
    eq(at('\uD834\uDF06def', NaN), '\uD834\uDF06');
    eq(at('\uD834\uDF06def', ''), '\uD834\uDF06');
    eq(at('\uD834\uDF06def', '_'), '\uD834\uDF06');
    eq(at('\uD834\uDF06def', '1'), '\uDF06');
    eq(at('\uD834abc', -Infinity), '');
    eq(at('\uD834abc', -1), '');
    eq(at('\uD834abc', -0), '\uD834');
    eq(at('\uD834abc', 0), '\uD834');
    eq(at('\uD834abc', 1), 'a');
    eq(at('\uD834abc', 42), '');
    eq(at('\uD834abc', Infinity), '');
    eq(at('\uD834abc', null), '\uD834');
    eq(at('\uD834abc', void 8), '\uD834');
    eq(at('\uD834abc'), '\uD834');
    eq(at('\uD834abc', false), '\uD834');
    eq(at('\uD834abc', NaN), '\uD834');
    eq(at('\uD834abc', ''), '\uD834');
    eq(at('\uD834abc', '_'), '\uD834');
    eq(at('\uD834abc', '1'), 'a');
    eq(at('\uDF06abc', -Infinity), '');
    eq(at('\uDF06abc', -1), '');
    eq(at('\uDF06abc', -0), '\uDF06');
    eq(at('\uDF06abc', 0), '\uDF06');
    eq(at('\uDF06abc', 1), 'a');
    eq(at('\uDF06abc', 42), '');
    eq(at('\uDF06abc', Infinity), '');
    eq(at('\uDF06abc', null), '\uDF06');
    eq(at('\uDF06abc', void 8), '\uDF06');
    eq(at('\uDF06abc'), '\uDF06');
    eq(at('\uDF06abc', false), '\uDF06');
    eq(at('\uDF06abc', NaN), '\uDF06');
    eq(at('\uDF06abc', ''), '\uDF06');
    eq(at('\uDF06abc', '_'), '\uDF06');
    eq(at('\uDF06abc', '1'), 'a');
    eq(at(42, 0), '4');
    eq(at(42, 1), '2');
    eq(at({
      toString: function(){
        return 'abc';
      }
    }, 2), 'c');
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return at(null, 0);
      }, TypeError);
      throws(function(){
        return at(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  test('String#padLeft', function(){
    var padLeft;
    padLeft = core.String.padLeft;
    ok(toString$.call(padLeft).slice(8, -1) === 'Function', 'Is function');
    eq(padLeft('abc', 5), '  abc');
    eq(padLeft('abc', 4, 'de'), 'eabc');
    eq(padLeft('abc'), 'abc');
    eq(padLeft('abc', 5, '_'), '__abc');
    eq(padLeft('', 0), '');
    eq(padLeft('foo', 1), 'foo');
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return padLeft(null, 0);
      }, TypeError);
      throws(function(){
        return padLeft(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  test('String#padRight', function(){
    var padRight;
    padRight = core.String.padRight;
    ok(toString$.call(padRight).slice(8, -1) === 'Function', 'Is function');
    eq(padRight('abc', 5), 'abc  ');
    eq(padRight('abc', 4, 'de'), 'abcd');
    eq(padRight('abc'), 'abc');
    eq(padRight('abc', 5, '_'), 'abc__');
    eq(padRight('', 0), '');
    eq(padRight('foo', 1), 'foo');
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return padRight(null, 0);
      }, TypeError);
      throws(function(){
        return padRight(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  test('String#trimLeft', function(){
    var trimLeft;
    trimLeft = core.String.trimLeft;
    ok(toString$.call(trimLeft).slice(8, -1) === 'Function', 'Is function');
    eq(trimLeft(' \n  q w e \n  '), 'q w e \n  ', 'removes whitespaces at left side of string');
    eq(trimLeft('\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u180E\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF'), '', 'removes all whitespaces');
    eq(trimLeft('\u200b\u0085'), '\u200b\u0085', "shouldn't remove this symbols");
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return trimLeft(null, 0);
      }, TypeError);
      throws(function(){
        return trimLeft(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  test('String#trimRight', function(){
    var trimRight;
    trimRight = core.String.trimRight;
    ok(toString$.call(trimRight).slice(8, -1) === 'Function', 'Is function');
    eq(trimRight(' \n  q w e \n  '), ' \n  q w e', 'removes whitespaces at right side of string');
    eq(trimRight('\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u180E\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF'), '', 'removes all whitespaces');
    eq(trimRight('\u200b\u0085'), '\u200b\u0085', "shouldn't remove this symbols");
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return trimRight(null, 0);
      }, TypeError);
      throws(function(){
        return trimRight(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, isFunction, slice, toString$ = {}.toString;
  QUnit.module('Mozilla JavaScript Array statics');
  eq = strictEqual;
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  slice = Array.prototype.slice;
  test('are functions', function(){
    var i$, x$, ref$, len$;
    for (i$ = 0, len$ = (ref$ = ['concat', 'join', 'pop', 'push', 'reverse', 'shift', 'slice', 'sort', 'splice', 'unshift', 'indexOf', 'lastIndexOf', 'every', 'some', 'forEach', 'map', 'filter', 'reduce', 'reduceRight', 'copyWithin', 'fill', 'find', 'findIndex', 'keys', 'values', 'entries', 'includes']).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(isFunction(core.Array[x$]), "Array." + x$ + " is function");
    }
  });
  test('.join', function(){
    var join;
    join = core.Array.join;
    eq(join('123'), '1,2,3');
    eq(join('123', '|'), '1|2|3');
    eq(join(function(){
      return arguments;
    }(3, 2, 1), '|'), '3|2|1');
  });
  test('.pop', function(){
    var pop, args;
    pop = core.Array.pop;
    ok(pop(args = function(){
      return arguments;
    }(1, 2, 3)) === 3);
    deepEqual(args, function(){
      return arguments;
    }(1, 2));
  });
  test('.push', function(){
    var push, args;
    push = core.Array.push;
    push(args = function(){
      return arguments;
    }(1, 2, 3), 4, 5);
    deepEqual(slice.call(args), [1, 2, 3, 4, 5]);
  });
  test('.reverse', function(){
    var reverse;
    reverse = core.Array.reverse;
    deepEqual(reverse(function(){
      return arguments;
    }(1, 2, 3)), function(){
      return arguments;
    }(3, 2, 1));
  });
  test('.shift', function(){
    var shift, args;
    shift = core.Array.shift;
    ok(shift(args = function(){
      return arguments;
    }(1, 2, 3)) === 1);
    deepEqual(args, function(){
      return arguments;
    }(2, 3));
  });
  test('.unshift', function(){
    var unshift, args;
    unshift = core.Array.unshift;
    unshift(args = function(){
      return arguments;
    }(1, 2, 3), 4, 5);
    deepEqual(slice.call(args), [4, 5, 1, 2, 3]);
  });
  test('.slice', function(){
    var slice;
    slice = core.Array.slice;
    deepEqual(slice('123'), ['1', '2', '3']);
    deepEqual(slice('123', 1), ['2', '3']);
    deepEqual(slice('123', 1, 2), ['2']);
    deepEqual(slice('123', 1, -1), ['2']);
    deepEqual(slice(function(){
      return arguments;
    }(1, 2, 3)), [1, 2, 3]);
    deepEqual(slice(function(){
      return arguments;
    }(1, 2, 3), 1), [2, 3]);
    deepEqual(slice(function(){
      return arguments;
    }(1, 2, 3), 1, 2), [2]);
    deepEqual(slice(function(){
      return arguments;
    }(1, 2, 3), 1, -1), [2]);
  });
  test('.splice', function(){
    var splice, args;
    splice = core.Array.splice;
    splice(args = function(){
      return arguments;
    }(1, 2, 3), 1, 0, 4, 5);
    deepEqual(slice.call(args), [1, 4, 5, 2, 3]);
    splice(args = function(){
      return arguments;
    }(1, 2, 3), 1, 1, 4);
    deepEqual(slice.call(args), [1, 4, 3]);
    splice(args = function(){
      return arguments;
    }(1, 2, 3), 1, 1);
    deepEqual(slice.call(args), [1, 3]);
  });
  test('.sort', function(){
    var sort;
    sort = core.Array.sort;
    deepEqual(sort(function(){
      return arguments;
    }(2, 1, 3)), function(){
      return arguments;
    }(1, 2, 3));
    deepEqual(sort(function(){
      return arguments;
    }(11, 2, 3)), function(){
      return arguments;
    }(11, 2, 3));
    deepEqual(sort(function(){
      return arguments;
    }(11, 2, 3), function(a, b){
      return a - b;
    }), function(){
      return arguments;
    }(2, 3, 11));
  });
  test('.indexOf', function(){
    var indexOf;
    indexOf = core.Array.indexOf;
    ok(indexOf('111', '1') === 0);
    ok(indexOf('123', '1', 1) === -1);
    ok(indexOf('123', '2', 1) === 1);
    ok(indexOf(function(){
      return arguments;
    }(1, 1, 1), 1) === 0);
    ok(indexOf(function(){
      return arguments;
    }(1, 2, 3), 1, 1) === -1);
    ok(indexOf(function(){
      return arguments;
    }(1, 2, 3), 2, 1) === 1);
  });
  test('.lastIndexOf', function(){
    var lastIndexOf;
    lastIndexOf = core.Array.lastIndexOf;
    ok(lastIndexOf('111', '1') === 2);
    ok(lastIndexOf('123', '3', 1) === -1);
    ok(lastIndexOf('123', '2', 1) === 1);
    ok(lastIndexOf(function(){
      return arguments;
    }(1, 1, 1), 1) === 2);
    ok(lastIndexOf(function(){
      return arguments;
    }(1, 2, 3), 3, 1) === -1);
    ok(lastIndexOf(function(){
      return arguments;
    }(1, 2, 3), 2, 1) === 1);
  });
  test('.every', function(){
    var every, al, ctx;
    every = core.Array.every;
    every(al = function(){
      return arguments;
    }(1), function(val, key, that){
      ok(this === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    ok(every('123', function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    ok(every('123', function(){
      return arguments[1] < 3;
    }));
    ok(!every('123', function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    ok(!every('123', function(){
      return arguments[1] < 2;
    }));
    ok(every('123', function(){
      return arguments[2] == '123';
    }));
    ok(every(function(){
      return arguments;
    }(1, 2, 3), function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
  });
  test('.some', function(){
    var some, al, ctx;
    some = core.Array.some;
    some(al = function(){
      return arguments;
    }(1), function(val, key, that){
      ok(this === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    ok(some('123', function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    ok(some('123', function(){
      return arguments[1] > 1;
    }));
    ok(!some('123', function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    ok(!some('123', function(){
      return arguments[1] > 3;
    }));
    ok(some('123', function(){
      return arguments[2] == '123';
    }));
    ok(some(function(){
      return arguments;
    }(1, 2, 3), function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
  });
  test('.forEach', function(){
    var forEach, al, ctx, val;
    forEach = core.Array.forEach;
    forEach(al = function(){
      return arguments;
    }(1), function(val, key, that){
      ok(this === ctx);
      ok(val === 1);
      ok(key === 0);
      ok(that === al);
    }, ctx = {});
    val = '';
    forEach('123', function(v, k, t){
      val += v + k + t;
    });
    ok(val === '101232112332123');
    val = '';
    forEach(function(){
      return arguments;
    }(1, 2, 3), function(v, k, t){
      val += v + k + t['2'];
    });
    ok(val === '468');
    val = '';
    forEach('123', function(v, k, t){
      val += v + k + t + this;
    }, 1);
    ok(val === '101231211231321231');
  });
  test('.map', function(){
    var map, al, ctx;
    map = core.Array.map;
    map(al = function(){
      return arguments;
    }(1), function(val, key, that){
      ok(this === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    deepEqual(map('123', (function(it){
      return Math.pow(it, 2);
    })), [1, 4, 9]);
    deepEqual(map(function(){
      return arguments;
    }(1, 2, 3), (function(it){
      return Math.pow(it, 2);
    })), [1, 4, 9]);
  });
  test('.filter', function(){
    var filter, al, ctx;
    filter = core.Array.filter;
    filter(al = function(){
      return arguments;
    }(1), function(val, key, that){
      ok(this === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    deepEqual(filter('123', function(it){
      return it > 1;
    }), ['2', '3']);
    deepEqual(filter(function(){
      return arguments;
    }(1, 2, 3), function(it){
      return it < 3;
    }), [1, 2]);
    deepEqual(filter('123', function(){
      return arguments[1] !== 1;
    }), ['1', '3']);
  });
  test('.reduce', function(){
    var reduce, al, ctx;
    reduce = core.Array.reduce;
    reduce(al = function(){
      return arguments;
    }(1), function(memo, val, key, that){
      ok(memo === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    reduce(al = function(){
      return arguments;
    }(1, 2), function(memo){
      return ok(memo === 1);
    });
    ok(reduce('123', function(a, b){
      a = +a;
      b = +b;
      return a + b;
    }) === 6);
    ok(reduce(function(){
      return arguments;
    }(1, 2, 3), function(a, b){
      return '' + b * b + a;
    }) === '941');
    ok(reduce('123', function(a, b){
      a = +a;
      b = +b;
      return a + b;
    }, 1) === 7);
  });
  test('.reduceRight', function(){
    var reduceRight, al, ctx;
    reduceRight = core.Array.reduceRight;
    reduceRight(al = function(){
      return arguments;
    }(1), function(memo, val, key, that){
      ok(memo === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    reduceRight(al = function(){
      return arguments;
    }(1, 2), function(memo){
      return ok(memo === 2);
    });
    ok(reduceRight('123', function(a, b){
      a = +a;
      b = +b;
      return a + b;
    }) === 6);
    ok(reduceRight(function(){
      return arguments;
    }(1, 2, 3), function(a, b){
      return '' + b * b + a;
    }) === '143');
    ok(reduceRight('123', function(a, b){
      a = +a;
      b = +b;
      return a + b;
    }, 1) === 7);
  });
  test('.copyWithin', function(){
    var copyWithin, a;
    copyWithin = core.Array.copyWithin;
    ok(copyWithin(a = function(){
      return arguments;
    }(1, 2, 3), 0) === a);
    deepEqual(copyWithin(function(){
      return arguments;
    }(1, 2, 3), -2), function(){
      return arguments;
    }(1, 1, 2));
    deepEqual(copyWithin(function(){
      return arguments;
    }(1, 2, 3), 0, 1), function(){
      return arguments;
    }(2, 3, 3));
    deepEqual(copyWithin(function(){
      return arguments;
    }(1, 2, 3), 0, 1, 2), function(){
      return arguments;
    }(2, 2, 3));
  });
  test('.fill', function(){
    var fill, a;
    fill = core.Array.fill;
    ok(fill(a = function(){
      return arguments;
    }(1, 2, 3), 0) === a);
    deepEqual(fill(Array(3), 5), [5, 5, 5]);
  });
  test('.find', function(){
    var find, al, ctx;
    find = core.Array.find;
    find(al = function(){
      return arguments;
    }(1), function(val, key, that){
      ok(this === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    ok(find(function(){
      return arguments;
    }(1, 3, NaN, 42, {}), (function(it){
      return it === 42;
    })) === 42);
    ok(find('123', (function(it){
      return it === '2';
    })) === '2');
    ok(find('123', (function(it){
      return it === '4';
    })) === void 8);
  });
  test('.findIndex', function(){
    var findIndex, al, ctx;
    findIndex = core.Array.findIndex;
    findIndex(al = function(){
      return arguments;
    }(1), function(val, key, that){
      ok(this === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    ok(findIndex(function(){
      return arguments;
    }(1, 3, NaN, 42, {}), (function(it){
      return it === 42;
    })) === 3);
    ok(findIndex('123', (function(it){
      return it === '2';
    })) === 1);
    ok(findIndex('123', (function(it){
      return it === '4';
    })) === -1);
  });
  test('.keys', function(){
    var keys, iter1, iter2;
    keys = core.Array.keys;
    ok(typeof keys === 'function', 'Is function');
    iter1 = keys(function(){
      return arguments;
    }('q', 'w', 'e'));
    ok(typeof iter1 === 'object', 'Iterator is object');
    ok(typeof iter1.next === 'function', 'Iterator has .next method');
    deepEqual(iter1.next(), {
      value: 0,
      done: false
    });
    deepEqual(iter1.next(), {
      value: 1,
      done: false
    });
    deepEqual(iter1.next(), {
      value: 2,
      done: false
    });
    deepEqual(iter1.next(), {
      value: void 8,
      done: true
    });
    iter2 = keys('qwe');
    deepEqual(iter2.next(), {
      value: 0,
      done: false
    });
    deepEqual(iter2.next(), {
      value: 1,
      done: false
    });
    deepEqual(iter2.next(), {
      value: 2,
      done: false
    });
    deepEqual(iter2.next(), {
      value: void 8,
      done: true
    });
  });
  test('.values', function(){
    var values, iter1, iter2;
    values = core.Array.values;
    ok(typeof values === 'function', 'Is function');
    iter1 = values(function(){
      return arguments;
    }('q', 'w', 'e'));
    ok(typeof iter1 === 'object', 'Iterator is object');
    ok(typeof iter1.next === 'function', 'Iterator has .next method');
    deepEqual(iter1.next(), {
      value: 'q',
      done: false
    });
    deepEqual(iter1.next(), {
      value: 'w',
      done: false
    });
    deepEqual(iter1.next(), {
      value: 'e',
      done: false
    });
    deepEqual(iter1.next(), {
      value: void 8,
      done: true
    });
    iter2 = values('qwe');
    deepEqual(iter2.next(), {
      value: 'q',
      done: false
    });
    deepEqual(iter2.next(), {
      value: 'w',
      done: false
    });
    deepEqual(iter2.next(), {
      value: 'e',
      done: false
    });
    deepEqual(iter2.next(), {
      value: void 8,
      done: true
    });
  });
  test('.entries', function(){
    var entries, iter1, iter2;
    entries = core.Array.entries;
    ok(typeof entries === 'function', 'Is function');
    iter1 = entries(function(){
      return arguments;
    }('q', 'w', 'e'));
    ok(typeof iter1 === 'object', 'Iterator is object');
    ok(typeof iter1.next === 'function', 'Iterator has .next method');
    deepEqual(iter1.next(), {
      value: [0, 'q'],
      done: false
    });
    deepEqual(iter1.next(), {
      value: [1, 'w'],
      done: false
    });
    deepEqual(iter1.next(), {
      value: [2, 'e'],
      done: false
    });
    deepEqual(iter1.next(), {
      value: void 8,
      done: true
    });
    iter2 = entries('qwe');
    deepEqual(iter2.next(), {
      value: [0, 'q'],
      done: false
    });
    deepEqual(iter2.next(), {
      value: [1, 'w'],
      done: false
    });
    deepEqual(iter2.next(), {
      value: [2, 'e'],
      done: false
    });
    deepEqual(iter2.next(), {
      value: void 8,
      done: true
    });
  });
  test('.includes', function(){
    var includes, args, o, str;
    includes = core.Array.includes;
    ok(isFunction(includes), 'Is function');
    args = function(){
      return arguments;
    }(1, 2, 3, -0, NaN, o = {});
    ok(includes(args, 1));
    ok(includes(args, -0));
    ok(includes(args, 0));
    ok(includes(args, NaN));
    ok(includes(args, o));
    ok(!includes(args, 4));
    ok(!includes(args, -0.5));
    ok(!includes(args, {}));
    str = 'qwe';
    ok(includes(str, 'q'));
    ok(!includes(str, 'r'));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, toString$ = {}.toString;
  QUnit.module('DOM iterable');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  if ((typeof NodeList != 'undefined' && NodeList !== null) && ((typeof document != 'undefined' && document !== null) && document.querySelectorAll) && toString$.call(document.querySelectorAll('div')).slice(8, -1) === 'NodeList') {
    test('NodeList.prototype@@iterator', function(){
      ok(core.isIterable(document.querySelectorAll('div')), 'Is iterable');
    });
  }
  if ((typeof HTMLCollection != 'undefined' && HTMLCollection !== null) && ((typeof document != 'undefined' && document !== null) && document.getElementsByTagName) && toString$.call(document.getElementsByTagName('div')).slice(8, -1) === 'HTMLCollection') {
    test('HTMLCollection.prototype@@iterator', function(){
      ok(core.isIterable(document.getElementsByTagName('div')), 'Is iterable');
    });
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, eq, timeLimitedPromise, setImmediate, clearImmediate, Promise, toString$ = {}.toString;
  QUnit.module('Immediate');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  eq = strictEqual;
  timeLimitedPromise = function(time, fn){
    return Promise.race([
      new Promise(fn), new Promise(function(res, rej){
        return setTimeout(rej, time);
      })
    ]);
  };
  setImmediate = core.setImmediate, clearImmediate = core.clearImmediate, Promise = core.Promise;
  test('setImmediate / clearImmediate', function(it){
    var def;
    it.expect(6);
    ok(isFunction(setImmediate), 'setImmediate is function');
    ok(isFunction(clearImmediate), 'clearImmediate is function');
    timeLimitedPromise(1e3, function(res){
      return setImmediate(function(){
        def = 'a';
        return res();
      });
    }).then(function(){
      return ok(true, 'setImmediate works');
    })['catch'](function(){
      return ok(false, 'setImmediate works');
    }).then(it.async());
    eq(def, void 8, 'setImmediate is async');
    timeLimitedPromise(1e3, function(res){
      return setImmediate(function(a, b){
        return res(a + b);
      }, 'a', 'b');
    }).then(function(it){
      return eq(it, 'ab', 'setImmediate works with additional args');
    })['catch'](function(){
      return ok(false, 'setImmediate works with additional args');
    }).then(it.async());
    timeLimitedPromise(50, function(res){
      return clearImmediate(setImmediate(res));
    }).then(function(){
      return ok(false, 'clearImmediate works');
    })['catch'](function(){
      return ok(true, 'clearImmediate works');
    }).then(it.async());
  });
  (function(it){
    if (typeof window != 'undefined' && window !== null) {
      return window.onload = it;
    } else {
      return it();
    }
  })(function(){
    return setTimeout(function(){
      var x, now, inc;
      x = 0;
      now = +new Date;
      return (inc = function(){
        return setImmediate(function(){
          x = x + 1;
          if (+new Date() - now < 5e3) {
            return inc();
          } else {
            return typeof console != 'undefined' && console !== null ? console.log("setImmediate: " + x / 5 + " per second") : void 8;
          }
        });
      })();
    }, 5e3);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, setTimeout, setInterval, Promise, timeLimitedPromise;
  QUnit.module('Timers');
  eq = strictEqual;
  setTimeout = core.setTimeout, setInterval = core.setInterval, Promise = core.Promise;
  timeLimitedPromise = function(time, fn){
    return Promise.race([
      new Promise(fn), new Promise(function(res, rej){
        return setTimeout(rej, time);
      })
    ]);
  };
  test('setTimeout / clearTimeout', function(it){
    it.expect(2);
    timeLimitedPromise(1e3, function(res){
      return setTimeout(function(a, b){
        return res(a + b);
      }, 10, 'a', 'b');
    }).then(function(it){
      return eq(it, 'ab', 'setTimeout works with additional args');
    })['catch'](function(){
      return ok(false, 'setTimeout works with additional args');
    }).then(it.async());
    timeLimitedPromise(50, function(res){
      return clearTimeout(setTimeout(res, 10));
    }).then(function(){
      return ok(false, 'clearImmediate works with wraped setTimeout');
    })['catch'](function(){
      return ok(true, 'clearImmediate works with wraped setTimeout');
    }).then(it.async());
  });
  test('setInterval / clearInterval', function(it){
    var i;
    it.expect(1);
    i = 0;
    timeLimitedPromise(1e4, function(res, rej){
      var interval;
      return interval = setInterval(function(a, b){
        if (a + b !== 'ab' || i > 2) {
          rej({
            a: a,
            b: b,
            i: i
          });
        }
        if (i++ === 2) {
          clearInterval(interval);
          return setTimeout(res, 30);
        }
      }, 5, 'a', 'b');
    }).then(function(){
      return ok(true, 'setInterval & clearInterval works with additional args');
    })['catch'](function(arg$){
      var ref$, a, b, i;
      ref$ = arg$ != null
        ? arg$
        : {}, a = ref$.a, b = ref$.b, i = ref$.i;
      return ok(false, "setInterval & clearInterval works with additional args: " + a + ", " + b + ", times: " + i);
    }).then(it.async());
  });
}).call(this);
